if not srb2p return end

DNG_Abilities["elie"] = {

    jfunc =     function(p)
                    local mo = p.mo

                    p.drawangle = mo.angle
                    mo.momz = 0
                    local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
                    t.color = mo.color
                    P_InstaThrust(mo,mo.angle,(46*FRACUNIT))
                    S_StartSound(p.mo,sfx_spdpad)
					mo.state = S_PLAY_ROLL
                end,

        func =        function(p)
                    local mo = p.mo

                    if mo.p_abl
                        if not P_IsObjectOnGround(mo)
                            if (leveltime%3)
                                local g = P_SpawnGhostMobj(mo)
                                g.tics = 4
                                g.colorized = true
                            end
                        else
                            mo.p_abl = false
                        end
                    end
                end,
}

freeslot("SPR_BATE", "SPR_ELCH", "SPR_ELDE", "SPR_ELFI", "SPR_ELGN", "SPR_ELRP",
 "SPR_ELST", "sfx_elgun", "sfx_elgry", "sfx_elspk", "sfx_elthr", "sfx_aercan", 
 "sfx_arcann", "sfx_antisp", "sfx_preaer", "sfx_aersik", "sfx_fortun", "sfx_aerial", 
 "sfx_aersto", "sfx_sanfor", "sfx_ragblt", "sfx_spaarw", "sfx_judbol", "sfx_gallan", 
 "sfx_grastr", "sfx_ragvor")

charStats["elie"] = {

		-- GENERAL

		name = "Elie",			-- This is only for bots / enemies
		basehp = 62,			-- base HP for level 1
		basesp = 64,
		persona = "elieskillset",
		melee_natk = "revolver",	-- normal melee attack
		melee_satk = "aerialcannon",
		
		supercolor_start = SKINCOLOR_SUPERELIE1,
		
		wep = "ingrid",		-- default weapon.
		weptype = WPT_GENERICRANGED,	-- Equippable weapon type(s)

		atk = 40,
		acc = 90,
		crit = 5,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATE, A, 8, "SPR2_BATE"},					-- standing
		anim_stand_hurt =	{SPR_BATE, A, 1, "SPR2_BATE"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATE, A, 8, "SPR2_BATE"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_ELDE, A, 1, "SPR2_ELDE"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_ELGN, A, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_ELRP, A, 1, "SPR2_ELRP"},					-- is down
		anim_getup =		{SPR_BATE, A, 1, "SPR2_BATE"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_ELCH, A, 8, "SPR2_ELCH"},
		anim_evoker_shoot = {SPR_ELFI, A, 8, "SPR2_ELFI"},
		anim_special1 =		{SPR_ELGN, A, 1, "SPR2_ELGN"},
		anim_special2 =		{SPR_ELST, A, B, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, C, 2, "SPR2_ELST"},
		
		vfx_summon = {"sfx_elsmn1", "sfx_elsmn2", "sfx_elsmn3", "sfx_elsmn4", "sfx_elsmn5"},
		vfx_skill = {"sfx_elskl1", "sfx_elskl2", "sfx_elskl3", "sfx_elskl4"},
		vfx_item = {"sfx_elitem"},
		vfx_hurt = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_hurtx = {"sfx_elhrt2"},
		vfx_die = {"sfx_elrip"},
		vfx_heal = {"sfx_elhel1", "sfx_elhel2"},
		vfx_healself = {"sfx_eldog1"},
		vfx_kill = {"sfx_elkil1", "sfx_elkil2", "sfx_elkil3"},
		vfx_1more = {"sfx_el1mo", "sfx_el1mor"},
		vfx_crit = {"sfx_elcrt1", "sfx_elcrt2", "sfx_elcrt3", "sfx_elcrt4"},
		vfx_aoaask = {"sfx_elaoi1", "sfx_elaoi2", "sfx_elaoi3"},
		vfx_aoado = {"sfx_elaoa1", "sfx_elaoa2"},
		vfx_aoarelent = {"sfx_eldog2"},
		vfx_miss = {"sfx_elmis1", "sfx_elmis2"},
		vfx_dodge = {"sfx_eldog1", "sfx_eldog2"},
		vfx_win = {"sfx_elwin1", "sfx_elwin2", "sfx_elwin3", "sfx_elwin4"},
		vfx_levelup = {"sfx_elkil2"},
		vfx_tartarus_pit = {"sfx_elrip"},
		vfx_tartarus_item = {"sfx_elitm2"},
		vfx_tartarus_spring = {"sfx_elspng"},
		vfx_tartarus_spike = {"sfx_elhrt1", "sfx_elhrt2", "sfx_elhrt3"},
		vfx_tartarus_critspike = {"sfx_elhrt2"},
		vfx_tartarus_spikepit = {"sfx_elmpit"},

		icon = "H_ELEICO",	-- icon for net select and other menus
		hudbust = "H_ELEBAR",			-- patch to draw on the stat hud
		hudaoa = "H_ELEAOA",	-- patch for all out attack hud
		hudcutin = "ELIE_A",	-- cut in
		aoa_quote = "They are down!\nLet's go everyone!",

		tip = "A member of the Special Support Section with Wind and Elec orbal arts using the ARCUS Orbment. With her orbal gun she can use powerful Pierce skills to shoot down the enemies. She also has a buff and a Dekunda Skill",
}

VFX_freeslotC("elie") 
	
personaList["elieskillset"] = {
		-- GENERAL
		name = "Elie",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk = 		{SPR_NULL, A, 8},
		startframe = 0,

		strength = 10,
		magic = 11,
		endurance = 7,
		luck = 5,
		agility = 8,
		weak = ATK_PSY,
		resist = ATK_WIND|ATK_ELEC,
		skills = {
						{"air_strike", 1}, {"snap", 4},
						{"sparkle", 9}, {"innocence_arc", 15}, {"aerial", 17},
						{"aero_sickle", 20, "air_strike"}, {"saintly_force", 22},
						{"antistep", 23}, {"spark_arrow", 26, "sparkle"},
						{"assault shot", 28, "snap"}, {"gale_lance", 30, "aerial"},
						{"wind boost", 35},  {"fortuna", 36, "saintly_force"},
						{"heavy shot", 37, "assault shot"}, {"antistepall", 40, "antistep"},
						{"triple_burst", 44, "heavy shot"}, {"grand_stream", 49, "aero_sickle"}, 
						{"triple_piercer", 53, "triple_burst"},
						{"wind amp", 57, "wind boost"},
						{"ragna_blast", 60, "spark_arrow"}, {"aero_storm", 66, "gale_lance"},
						{"ragna_vortex", 74, "grand_stream"},
						{"judgement_bolt", 79, "ragna_blast"},
						
				},
}

attackDefs["revolver"] = {
	name = "Revolver Shot",
	type = ATK_PIERCE,
	power = 38,
	accuracy = 95,
	critical = 6,
	target = TGT_ENEMY,
	costtype = CST_HP,
	cost = 0,
	desc = "Shoots a bullet to a enemy",
	physical = true,
	anim = function(mo, targets, hittargets, timer)
		local target = targets[1]
		local btl = server.P_BattleStatus[mo.battlen]
		local cam = btl.cam
		
		if timer == 1
			ANIM_set(mo, mo.anim_special1)
			playSound(mo.battlen, sfx_elgry)
			mo.oldangle = mo.angle
			mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
			cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
		elseif timer == 5*TICRATE/8
			local cx = target.x + 168*cos(target.angle + ANG1*20)
			local cy = target.y + 168*sin(target.angle + ANG1*20)
			CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
		end
		
		if timer == 1*TICRATE/2
			playSound(mo.battlen, sfx_elgun)
		end
		
		if timer == 3*TICRATE/4
			damageObject(hittargets[1])
			playSound(mo.battlen, sfx_lydhit)
			P_StartQuake(FRACUNIT*7, 4)
			for i = 1, 2
				createSplat(mo)
			end
		end
		if timer == 3*TICRATE/2
			return true
		end
	end,
}

attackDefs["aerialcannon"] = {
	name = "Aerial Cannon",
	type = ATK_ALMIGHTY,
	power = 45,
	accuracy = 999,
	critical = 6,
	nometronome = true,
	norandom = true,
	target = TGT_ALLENEMIES, //Here I go
	costtype = CST_SP, //Special SP
	cost = 300,
	status = COND_BURN, //Idk lol
	statuschance = 15, 
	hits = 36, //Lets hit many times at random targets before a final kablewy - So.. Max times an enemy can be hit
	desc = "Elie's S-Craft\nPrays for Aidios to give power\nand shoots explosive shots",
	//physical = true, Yes I know I like cut-ins 
	anim = function(mo, targets, hittargets, timer)
	//Lets setup DaCamera first
		local cam = server.P_BattleStatus[mo.battlen].cam
		local ctgt = hittargets[1] //And aim at a random fucker
		local rnd = P_RandomRange(1,#hittargets) //Why yes I did steal from myself twice
		local rtgt = hittargets[rnd] //So incase we go for a random fucker
		if timer == 1
			ANIM_set(mo, mo.anim_special1, true)//Do this anim
			playSound(mo.battlen, sfx_cutlyd)
			playSound(mo.battlen, sfx_aercan)
			mo.angle = R_PointToAngle2(mo.x,mo.y,ctgt.x,ctgt.y) //Okay look at "1"
			//And of course, Camera
			local cx = mo.x + 192*cos(mo.angle)
			local cy = mo.y + 192*sin(mo.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Hello camera, welcome back
		elseif timer == 15
		//Make da bwWQUEwUW thing like the coool vfx thing this is how: THOK
			local cx = mo.x + 8*cos(mo.angle)
			local cy = mo.y + 8*sin(mo.angle)//TAKe this, thanks
			local thok = P_SpawnMobj(cx, cy, mo.z + FRACUNIT*40, MT_DUMMY)//At this Z height
			thok.color = SKINCOLOR_TEAL //Looks teal..?
			thok.frame = A|FF_FULLBRIGHT //Make it not transparent
			thok.tics = 90 //For 90 - 2 seconds + 20 frames
			thok.scale = FRACUNIT*2 //2 seems good
			mo.nrg = thok //This can now be called to as "mo.nrg"
		elseif timer >= 50 //One second later..
		and timer < 85
			local cx = mo.x + 192*cos(mo.angle+ANGLE_225)
			local cy = mo.y + 192*sin(mo.angle+ANGLE_225) //Tilted
			local ccx = mo.x + 9*cos(mo.angle)
			local ccy = mo.y + 9*sin(mo.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			local thok = P_SpawnMobj(ccx,ccy, mo.nrg.z + 16*FRACUNIT, MT_DUMMY) //Spawn cool stuff from the main
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_CYAN
				if timer%3 then thok.color = SKINCOLOR_ICY end
				if timer%2 then thok.color = SKINCOLOR_MINT end
				thok.frame = A
				thok.tics = 10
				thok.scale = FRACUNIT
				thok.scalespeed = FRACUNIT/11
				thok.destscale = 1
				thok.momz = P_RandomRange(-10, 10)*FRACUNIT
				thok.momx = P_RandomRange(-10, 10)*FRACUNIT
				thok.momy = P_RandomRange(-10, 10)*FRACUNIT
		elseif timer >=85
		and timer < 105
			if timer == 85
			playSound(mo.battlen, sfx_arcann)
			local cx = mo.x + 384*cos(mo.angle+ANGLE_225)
			local cy = mo.y + 384*sin(mo.angle+ANGLE_225) //Zoom out
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			end
			if not (timer%2)
			local shot = P_SpawnMobj(mo.nrg.x + P_RandomRange(-16, 16)*FRACUNIT, mo.nrg.y + P_RandomRange(-16, 16)*FRACUNIT, mo.nrg.z + P_RandomRange(-16, 16)*FRACUNIT, MT_DUMMY)
				if not (timer%4)
					playSound(mo.battlen, sfx_elgun)
				end
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_TEAL //Pew pew effects
				shot.scale = (P_RandomRange(1,12)*FRACUNIT)/4
			end
		elseif timer == 105
			cam.momx = 0
			cam.momy = 0
			local cx = ctgt.x + 512*cos(ctgt.angle + ANG1*200)
			local cy = ctgt.y + 512*sin(ctgt.angle + ANG1*200) //Cool angle?
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*24)//...No guarantee
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, ctgt.x, ctgt.y)
		elseif timer >= 110
		and timer < 145 //35 seconds... Fuck em up.
			local booma = P_SpawnMobj(rtgt.x+P_RandomRange(-20, 20)*FRACUNIT, rtgt.y+P_RandomRange(-20, 20)*FRACUNIT, rtgt.z+P_RandomRange(-20, 20)*FRACUNIT, MT_BOSSEXPLODE)
				if not (leveltime%10)
					playSound(mo.battlen, sfx_tiexp)
				end
				booma.scale = FRACUNIT*3
				booma.state = S_QUICKBOOM1
				booma.colorized = true
				booma.color = SKINCOLOR_TEAL
			local boomb = P_SpawnMobj(rtgt.x+P_RandomRange(-64, 64)*FRACUNIT, rtgt.y+P_RandomRange(-64, 64)*FRACUNIT, rtgt.z+20*FRACUNIT, MT_BOSSEXPLODE)
				boomb.scale = FRACUNIT*4
				boomb.state = S_PFIRE1
				booma.colorized = true
				booma.color = SKINCOLOR_CYAN
			damageObject(rtgt) //BABABABABABABABAABALAAAAAST KABLEWYYYYYYYYYYYYYYYYYYYYYYY
			localquake(mo.battlen, FRACUNIT*24, 3) //Hyperactive Zoraxua moment: fukin TREMBLE the camera lol
		end
			local j = mo.columns and #mo.columns or 0
			while j
				local m = mo.columns[j]
				if not m or not m.valid
					j = $-1
					continue
				end

				for i = 1, 5
					local boom = P_SpawnMobj(m.x + P_RandomRange(-48, 48)*FRACUNIT, m.y + P_RandomRange(-48, 48)*FRACUNIT, m.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_AQUA
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3
				end
				P_StartQuake(FRACUNIT*8, 1)
				j = $-1
			end //Setup the KANNON BOOOOOM
		if timer >= 125
		and timer < 145
			if timer == 125
				DoExplosion(ctgt)
			end
			for i = 1, 12
				local boom = P_SpawnMobj(ctgt.x + P_RandomRange(-48, 48)*FRACUNIT, ctgt.y + P_RandomRange(-48, 48)*FRACUNIT, ctgt.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1 //One person gets the biggest lol
				boom.colorized = true
				boom.color = SKINCOLOR_LIME
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
			end
		elseif timer == 145
			for k,v in ipairs(mo.allies)
				if v and v.control and v.control.valid
					P_FlashPal(v.control, 4, 10) //Redpal flash
				end
			end
		P_StartQuake(FRACUNIT*32, 15)//AGAIN AGAIN
		//It's time..
			for i = 1,#hittargets
				local target = hittargets[i]
				damageObject(target)
				local smol = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
				smol.colorized = true
				smol.color = SKINCOLOR_TEAL
			end
			DoExplosion(ctgt)
			mo.fangle = (R_PointToAngle(ctgt.x, ctgt.y)) + ANG1*180
			mo.columns = {}
			playSound(mo.battlen, sfx_megi5)
			//For my KANNON ! ! !

			local a = mo.fangle - ANG1*80

			for i = 1, 16
				local m = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_DUMMY)
				P_InstaThrust(m, a, FRACUNIT*48)
				mo.columns[#mo.columns+1] = m
				m.state = S_INVISIBLE
				m.tics = TICRATE
				a = $+ ANG1*10
			end
		elseif timer == 170 //Wrap it up
			for i = 1,#hittargets
				local target = hittargets[i]
				local smol = P_SpawnMobj(ctgt.x, ctgt.y, ctgt.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3
				smol.colorized = true
				smol.color = SKINCOLOR_SEAFOAM //More smoldering
			end
			mo.nrg = nil //Buh-bye
			return true
		end
	end, //Zoraxua moment: Let me error 6 times for missing commas
}

attackDefs["air_strike"] = {
		name = "Air Strike",
		type = ATK_WIND,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		technical = COND_BURN,
		cost = 4,
		desc = "Orbal Art.\nLight Wind Damage to a enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local t = hittargets[1]

			if timer == 20

				for i = 1, 5
					local g = P_SpawnMobj(mo.x, mo.y, mo.z + P_RandomRange(0, 60)*FRACUNIT, MT_GARU)
					g.target = mo
					g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
					if i == 3
						g.jizzcolor = true
						g.invertrotation = true
					end
					g.dist = P_RandomRange(25, 50)
					g.tics = 20
				end

			elseif timer == 30
				playSound(mo.battlen, sfx_wind1)
				local thok = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
				thok.scale = 1
				thok.destscale = FRACUNIT*2
				thok.scalespeed = (FRACUNIT*2)/10
				thok.frame = A|FF_FULLBRIGHT
				thok.color = SKINCOLOR_EMERALD
				thok.tics = 10
			end
			if timer >= 35 and timer <= 42
				if timer == 42
					damageObject(t)
					playSound(mo.battlen, sfx_rail1)
					playSound(mo.battlen, sfx_rail2)
				end
				local ax = t.x + P_RandomRange(-20,20)*FRACUNIT
				local ay = t.y + P_RandomRange(-20,20)*FRACUNIT
				local thok = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
				thok.scale = FRACUNIT
				thok.frame = A|FF_FULLBRIGHT
				thok.color = SKINCOLOR_GREEN
				thok.flags2 = $|MF2_SPLAT 
				thok.tics = 6
				thok.momx = (ax - thok.x)/6
				thok.momy = (ay - thok.y)/6
				thok.momz = (t.z - thok.z)/6
			end
			if timer == 75
				return true
			end
		end,
}

attackDefs["aerial"] = {
		name = "Aerial",
		type = ATK_WIND,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art.\nLight Wind Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies
			if timer < 20
				local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
				local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
				t.color = SKINCOLOR_LIME
				t.momz = (P_RandomRange(8,64)/4)*FRACUNIT
			elseif timer >= 20 and timer < 60
				local t = P_SpawnMobj (avgx,avgy,mo.floorz,MT_THOK)
				t.color = SKINCOLOR_EMERALD
				t.scale = FRACUNIT*#hittargets
				t.momz = 20*FRACUNIT
				t.tics = 35
				for h = 1,#hittargets
					local target = hittargets[h]
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,(FRACUNIT*(timer - 20))/10)
					end	
				end
			end
			if timer == 17
				local dust = P_SpawnMobj(avgx,avgy,mo.floorz,MT_DUSTDEVIL)
				dust.scale = (FRACUNIT/2)*#hittargets
				mo.nado = dust
			end

			if timer == 60
				playSound(mo.battlen, sfx_hit)
				for h = 1,#hittargets
					damageObject(hittargets[h])
					local target = hittargets[h]
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,FRACUNIT*20)
					end	
				end
				
				mo.nado.fuse = 1
				mo.nado = nil
			end
			if timer == 1
				playSound(mo.battlen, sfx_aerial)
			end
			if timer == 90
				return true
			end
		end,
}

attackDefs["aero_sickle"] = {
		name = "Aero Sickle",
		type = ATK_WIND,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art.\nMedium Wind Damage to a enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
			local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
			local wepz = mo.z + FRACUNIT*40
			//PUPPY DO A LUA yet again
			//hERES MY AWESOME WEPX WEPY WEPZ DEFS AWESOME
			if timer == 1 
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				//Aim and Look fuckface
			end
			if timer < 35
				local s = P_SpawnMobj(wepx, wepy, wepz, MT_DUMMY)
				s.scale = FRACUNIT
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = 1
				s.scalespeed = FRACUNIT/5
				s.tics = 5
				s.rollangle = ANG1*P_RandomRange(1,360)
				//Wind "energy"
			end
			if timer == 35
				local thok = P_SpawnMobj(wepx, wepy, wepz, MT_DUMMY)	
				thok.color = SKINCOLOR_EMERALD
				thok.frame = A|FF_FULLBRIGHT
				thok.flags2 = $|MF2_SPLAT
				thok.tics = 50 //2* target hit time - make it resume on
				thok.scale = mo.scale
				thok.momx = (target.x - thok.x)/25
				thok.momy = (target.y - thok.y)/25
				thok.momz = (target.z - thok.z)/25
				//Why yes I did take this from Zorua's attacks! WELL I made the lua so I CAN STEAL FROM MYSELF (Yes this is the dumb Slybrid btw)
				mo.windblob = thok //Okay set this as an object so we can throw bullshit around! AWesome!
				playSound(mo.battlen, sfx_s3k4b)
			end
			
			if timer == 60
				damageObject(target)
				if target.damagestate ~= DMG_MISS
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN
					P_SetObjectMomZ(target,FRACUNIT*17,true)
					playSound(mo.battlen, sfx_aersik)
				else
					playSound(mo.battlen, sfx_s3k47)
				end	
				for i = 1,20
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					thok.color = SKINCOLOR_MINT
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 105
					thok.scale = mo.scale/2
					thok.destscale = 1
					thok.scalespeed = (mo.scale/2)/105
					thok.momx = P_RandomRange(-15,15)*FRACUNIT
					thok.momy = P_RandomRange(-15,15)*FRACUNIT
					thok.momz = P_RandomRange(5,15)*FRACUNIT
				end//Also swiped from the Tricky Fox
			end
			//We speculate to stike here - So lets damage here!
			if timer < 85 and mo.windblob
				local s = P_SpawnMobj(mo.windblob.x, mo.windblob.y, mo.windblob.z, MT_DUMMY)
				s.scale = FRACUNIT/2
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = 1
				s.scalespeed = (FRACUNIT/2)/min(5,mo.windblob.tics)
				s.tics = min(5,mo.windblob.tics)
				s.rollangle = ANG1*P_RandomRange(1,360)
				s.momx = mo.windblob.momx
				s.momy = mo.windblob.momy
			end 
			//Spawn winds by the windblob
			if timer == 85
				if mo.windblob
					mo.windblob = nil
				end
				return true
			end
			if timer == 10
			playSound(mo.battlen, sfx_preaer) 
			end
		end,
}

attackDefs["gale_lance"] = {
	name = "Gale Lance",
	type = ATK_WIND,
	power = 140,
	accuracy = 90,
	costtype = CST_SP,
	cost = 16,
	desc = "Orbal Art.\nMedium Wind Damage to all enemies",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
	
		if timer == 10
			S_StartSound(nil, sfx_gallan)
		end	
		
		if timer >= 10
		and timer <= 50
			if leveltime%3 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.state = S_HOWL1
				d.color = SKINCOLOR_AETHER
				d.angle = mo.angle + ANG1*90
				d.scale = mo.scale*5
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
				localquake(mo.battlen, FRACUNIT*10, 10)
			end
		end	
		
		if timer >= 10
		and timer <= 50
			if leveltime%3 == 0
				local d = P_SpawnMobj(mo.x, mo.y, mo.z + FRACUNIT*64, MT_THOK)
				d.sprite = SPR_SLAS
				d.color = SKINCOLOR_AETHER
				d.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				d.scale = FRACUNIT*9
				d.tics = TICRATE/3
				P_InstaThrust(d, mo.angle, FRACUNIT*32)
			end
		end	
		
		if timer == 40
			for k,v in ipairs(hittargets)
				damageObject(v)
			end	
		end
		
		if timer == 65 + 10*(#hittargets-1)
			return true
		end	
	end,
}
	
attackDefs["grand_stream"] = {
		name = "Grand Stream",
		type = ATK_WIND,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art.\nHeavy Wind Damage to a enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				playSound(mo.battlen, sfx_grastr)
			end	

			if timer > 20
			and timer < 110
			and leveltime%2 == 0
				local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*140, MT_DUMMY)
				s.scale = FRACUNIT/4
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = FRACUNIT*7
				s.scalespeed = FRACUNIT
				s.tics = TICRATE/3
			end

			if timer >= 20 and timer <= 110
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-20, 20)*FRACUNIT, target.y + P_RandomRange(-20, 20)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_GREEN
					if timer%2 then thok.color = SKINCOLOR_MINT end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 20)*FRACUNIT
					thok.momx = P_RandomRange(-20, 20)*FRACUNIT
					thok.momy = P_RandomRange(-20, 20)*FRACUNIT
				end
			end

			if timer > 20
			and timer < 110
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 180
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, target.z + target.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_EMERALD
					aura.momz = P_RandomRange(2, 16)*FRACUNIT
					aura.scale = FRACUNIT*1
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
				end		
	
			elseif timer == 111
				playSound(mo.battlen, sfx_hit)
				damageObject(target)
			elseif timer == 135
				target.elec = nil
				return true
			end

			if target.elec
			and target.elec.valid
			and not (leveltime%2)
				target.elec.frame = P_RandomRange(A, L)
			end
		end,
}

attackDefs["aero_storm"] = {
		name = "Aero Storm",
		type = ATK_WIND,
		power = 350,
		accuracy = 90,
		costtype = CST_SP,
		implicit = "elistarblast",
		cost = 24,
		desc = "Orbal Art.\nHeavy Wind Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies
			if timer < 20
				local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
				local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
				t.color = SKINCOLOR_LIME
				t.scale = 2*FRACUNIT
				t.momz = (P_RandomRange(8,64)/4)*FRACUNIT
			end
			if timer == 15
				local dust = P_SpawnMobj(avgx,avgy,mo.floorz,MT_DUSTDEVIL)
				dust.scale = max((FRACUNIT/2)*#hittargets,(FRACUNIT/2)*3)
				mo.nado = dust
			end
			if mo.nado and mo.nado.valid
				summonAura(mo.nado, SKINCOLOR_EMERALD)
			end
			if timer > 15 and timer < 105
				for h = 1,#hittargets
					local target = hittargets[h]
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,(FRACUNIT*(timer))/5)
					end	
				end
				if not (leveltime%3)
					local rx = avgx + P_RandomRange(-128,128)*FRACUNIT
					local ry = avgy + P_RandomRange(-128,128)*FRACUNIT
					local t = P_SpawnMobj (rx,ry,mo.floorz,MT_THOK)
					t.color = SKINCOLOR_LIME
					t.state = S_ROCKCRUMBLEA //maybe?
					t.scale = 2*FRACUNIT
					t.momz = (P_RandomRange(8,64)/2)*FRACUNIT
					t.fuse = 105
				end
			end
			if timer == 105
				mo.nado.fuse = 1
				mo.nado = nil
				for h = 1,#hittargets
					local target = hittargets[h]
					target.momz = (target.floorz - target.z)/15
					target.flags = $|MF_NOGRAVITY
				end
			end
			if timer == 120
				for h = 1,#hittargets
					local target = hittargets[h]
					damageObject(target)
					target.flags = $ & !MF_NOGRAVITY
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						P_SetObjectMomZ(target,FRACUNIT*10)
					end	
				end
				playSound(mo.battlen, sfx_pstop)
				localquake(mo.battlen, FRACUNIT*32, 25)
			end
			if timer == 1
				playSound(mo.battlen, sfx_aersto)
			end	
			if timer == 155
				return true
			end
		end,
}


attackDefs["sparkle"] = {
		name = "Sparkle",
		type = ATK_ELEC,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 4,
		desc = "Orbal Art.\nLight Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
            if (timer == 20)
				local z2 = P_SpawnMobj(target.x, target.y, target.floorz, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_TRSPARKLE1	, target.scale*15/4, SKINCOLOR_YELLOW
				z2.destscale = target.scale*3/2

				playSound(mo.battlen, sfx_elspk)
				damageObject(target)
			elseif (timer == 60)
				return true
			end
		end,
}

attackDefs["spark_arrow"] = {
		name = "Spark Arrow",
		type = ATK_ELEC,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 8,
		desc = "Orbal Art.\nMedium Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				playSound(mo.battlen, sfx_spaarw)
				playSound(mo.battlen, sfx_zio4)
			end	
			
			if timer >= 10 and timer <= 70
				local orb = P_SpawnMobj(mo.x, mo.y, mo.z + mo.height/2, MT_DUMMY)
				orb.sprite = SPR_DELK
				orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				orb.color = SKINCOLOR_CYAN
				orb.destscale = FRACUNIT*4
				orb.scalespeed = FRACUNIT/4
				orb.tics = TICRATE/8
			end
			
			if timer >= 10
			and timer <= 70
			and leveltime%3 == 0


				local range = 60
				if timer >= 50
					range = 100
				end

				local s = P_SpawnMobj(mo.x + P_RandomRange(-range, range)*mo.scale, mo.y + P_RandomRange(-range, range)*mo.scale, mo.z + P_RandomRange(0, 100)*mo.scale, MT_SUPERSPARK)
			end
			
			if timer == 40
			or timer == 45
			or timer == 50
			or timer == 55
                local boom = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*32,MT_DUMMY)
                boom.scale = FRACUNIT*1
				boom.sprite = SPR_MAGN
				boom.colorized = true
				boom.color = SKINCOLOR_CYAN
				boom.frame = A|FF_FULLBRIGHT
				boom.fuse = 17
				boom.momx = (target.x - boom.x)/5
				boom.momy = (target.y - boom.y)/5
				boom.momz = (target.z - boom.z)/5
				target.bruhn = boom
				playSound(mo.battlen, sfx_s3k40)
			end
			
			if timer == 65
				damageObject(target)
				S_StartSound(nil, sfx_s3k83)
			
			elseif timer == 90
				return true
			end
				
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_CYAN
			end
        end,				
}

attackDefs["ragna_blast"] = {
		name = "Ragna Blast",
		type = ATK_ELEC,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 12,
		desc = "Orbal Art.\nHeavy Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer < 50
				if timer == 1
					playSound(mo.battlen, sfx_zio5)
				end
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_MAGENTA
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_MAGENTA
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_MAGENTA
				s.scale = FRACUNIT*1
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
			end
			
			if timer == 50
				local z1 = P_SpawnMobj(mo.x, mo.y, mo.floorz, MT_DUMMY)
                z1.state, z1.scale, z1.color = S_LZIO11, mo.scale*9/4, SKINCOLOR_MAGENTA
                z1.destscale = mo.scale
			end	

			if timer == 70
				playSound(mo.battlen, sfx_ragblt)
			end	
			
			
			if timer >= 70 
			and timer <= 110
			and leveltime%2 == 0
			
				local range = 60
				if timer >= 50
					range = 100
				end
				local s = P_SpawnMobj(target.x + P_RandomRange(-range, range)*mo.scale, target.y + P_RandomRange(-range, range)*mo.scale, target.floorz + P_RandomRange(0, 100)*mo.scale, MT_DUMMY)
				s.state, s.scale, s.color = S_LZIO21, target.scale*15/4, SKINCOLOR_MAGENTA
				s.destscale = target.scale*3/2
			end	
			
			if timer == 111
				playSound(mo.battlen, sfx_elthr)
				lightningblast(target, SKINCOLOR_MAGENTA, FRACUNIT*3/2)
				localquake(mo.battlen, FRACUNIT*8, 8)
				damageObject(target)
			elseif timer == 135
				return true
			end
		end,
}

attackDefs["innocence_arc"] = {
		name = "Innocence Arc",
		dekunda = true,	-- see above w/ dekaja
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 10,
		desc = "Orbal Art\nRemove party debuffs",
		target = TGT_ALLALLIES,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_GOLD, SKINCOLOR_YELLOW, SKINCOLOR_LIME}
			local strs = {"atk", "mag", "def", "agi", "crit"}
			
			if timer == 20
				playSound(mo.battlen, sfx_curia)
			end

			for i = 1, #targets
				local target = targets[i]
				if timer == 20 + (i-1)*3
					for j = 1, 16
						local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						orb.momx = P_RandomRange(-16, 16)<<FRACBITS
						orb.momy = P_RandomRange(-16, 16)<<FRACBITS
						orb.momz = P_RandomRange(-16, 16)<<FRACBITS
						orb.destscale = 0
						orb.frame = A
						orb.color = colors[P_RandomRange(1, #colors)]
					end
					for j = 1, #strs
						local t = targets[i]
						local s = strs[j]
						if t.buffs[s][1] < 0
							t.buffs[s][1] = 0
							t.buffs[s][2] = 0
						end
					end
					BTL_logMessage(targets[1].battlen, "Debuffs removed")
				end
			end
			if timer == TICRATE*3/2 + (#targets-1)*10
				return true
			end
		end,
}

attackDefs["triple_burst"] = {
		name = "Triple Burst",
		type = ATK_PIERCE,
		power = 80,
		accuracy = 100,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		cost = 15,
		critical = 2,
		hits = 3,
		desc = "Fires three high-accuracy shots\ncausing Light Damage\nto one enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer >= 15 and timer <= 45
			and not (timer%2)

				local shot = P_SpawnMobj(target.x + P_RandomRange(-150, 150)*FRACUNIT, target.y + P_RandomRange(-150, 150)*FRACUNIT, target.z + P_RandomRange(0, 150)*FRACUNIT, MT_DUMMY)
				if not (timer%4)
					playSound(mo.battlen, sfx_elgun)
				end
				shot.state = S_STAB_1_1
				shot.color = SKINCOLOR_WHITE
				shot.scale = $ + P_RandomRange(0, 65535)*3

				if not (timer%8)
					createSplat(mo)
					P_StartQuake(FRACUNIT*4, 4)
				end

			end
			if timer == 30
			or timer == 40
			or timer == 50
				damageObject(target)
			elseif timer == 85
				return true
			end
		end,
}

attackDefs["triple_piercer"] = {
		name = "Triple Piercer",
		type = ATK_PIERCE,
		power = 120,
		accuracy = 120,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		cost = 22,
		critical = 2,
		hits = 3,
		desc = "Fires three high-accuracy shots\ncausing Medium Damage \nto one enemy",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local wepx = mo.x + 8*cos(mo.angle + ANGLE_45)
			local wepy = mo.y + 8*sin(mo.angle + ANGLE_45)
			local cx = mo.x + 128*cos(mo.angle + ANG1*202)
			local cy = mo.y + 128*sin(mo.angle + ANG1*202)
			local wepz = mo.z + FRACUNIT*40
			//Hello funny Slybrid here: This is my funky lil angle def for Elie's funny pewpew stick
			local cam = server.P_BattleStatus[mo.battlen].cam
			CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cam.x, cam.y, target.x, target.y))
			//CONSTANTLY be chasing the right angle!
			
			//MY MISCHIEF IS SCHEDULED:
			//Megido star, make some shocks, fire 2 shots looking with Thoks then the final one after a smaller pause - 5 5 15 in framedata (epic)
			local dist = (R_PointToDist2(mo.x,mo.y,target.x,target.y)/FRACUNIT)/2
			//Learning from Jolt's Supervolt, measure distance/FRACUNIT for special use.. mwehehe..
			
			
			if timer == 1
				//CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, FRACUNIT*40, 10*FRACUNIT) //Hm
				if mo.anim_special2 and #mo.anim_special2
					if mo.skin == "elie"
						ANIM_set(mo, mo.anim_special2)
					end	
				end
				playSound(mo.battlen, sfx_elgry)
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				//Looking at our victim!
			end//DO THE ANIM YOU DORK
			if timer == 10
				local s = P_SpawnMobj(wepx,wepy,wepz, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = mo.scale
				playSound(mo.battlen, sfx_hamas1)
			end
			//PREPARE the star!
			if timer == 40
				local thok = P_SpawnMobj(wepx,wepy,wepz, MT_THOK)
				thok.tics = 20
				thok.destscale = 1
				thok.scalespeed = FRACUNIT/20
				thok.color = SKINCOLOR_GOLD
			end
			//Charge they bwarb
			if timer == 45
			or timer == 55 //HITT TTWICE!! WOW EPIC
				for i = 1, dist //Lmao imagine having a bad pc	
					local dx = wepx + (i*4)*cos(mo.angle)
					local dy = wepy + (i*4)*sin(mo.angle)
					local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
					thok.scale = FRACUNIT/4
					thok.tics = 1
					thok.color = SKINCOLOR_YELLOW
					local g = P_SpawnGhostMobj(thok)
						g.fuse = 5
						g.color = thok.color
				end
				damageObject(target)
				for i = 1,15
					local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
					local rt = P_RandomRange(2,20)*FRACUNIT
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale
					p.colorized = true
					p.color = SKINCOLOR_GOLD
					p.angle = mo.angle + P_RandomRange(-30, 30)*ANG1
					p.momz = P_RandomRange(-12, 12)*mo.scale
					P_InstaThrust(p, p.angle, rt)
				end
				playSound(mo.battlen, sfx_elgun)
			end
			//Basically like a laser, I think it looks neat!
			if timer == 55
				local thok = P_SpawnMobj(wepx,wepy,FRACUNIT*10, MT_THOK)
				thok.tics = 15
				thok.scale = FRACUNIT*2
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT*2)/15
				thok.color = SKINCOLOR_MINT
				playSound(mo.battlen, sfx_s3k9c)
			end
			//3rd SHOT'S orb charge - This one actually ends at the start of the shot
			if timer == 70
				for i = 1, dist 
					local dx = wepx + (i*4)*cos(mo.angle)
					local dy = wepy + (i*4)*sin(mo.angle)
					local thok = P_SpawnMobj(dx,dy,wepz, MT_THOK)
					thok.scale = FRACUNIT/2
					thok.color = SKINCOLOR_TEAL
					thok.tics = 2
					local g = P_SpawnGhostMobj(thok)
						g.fuse = 35
						g.color = thok.color
				end
				damageObject(target)
				for i = 1,30
					local p = P_SpawnMobj(target.x, target.y, mo.z + 40*FRACUNIT, MT_DUMMY)
					local rt = P_RandomRange(2,35)*FRACUNIT
					p.flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY
					p.state = S_SSPK1
					p.scale = mo.scale
					p.colorized = true
					p.color = SKINCOLOR_EMERALD
					p.angle = mo.angle + P_RandomRange(-45, 45)*ANG1
					p.momz = P_RandomRange(-20, 20)*mo.scale
					P_InstaThrust(p, p.angle, rt)
				end
				playSound(mo.battlen, sfx_s3kc5l)
				playSound(mo.battlen, sfx_cdfm35)
				playSound(mo.battlen, sfx_cdfm35)
				//Final shot!! BAP!!!!! HAH!!!!
			end
			if timer == 105 //70 + TICRATE
				return true //Yaya
			end
		end,
}

attackDefs["saintly_force"] = {
		name = "Saintly Force",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nRaises magic attack to 1 ally \nby 1 stage",
		target = TGT_ALLY,
		buff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["mag"][1] >= 75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]	
			
			if timer == 10
				playSound(mo.battlen, sfx_sanfor)
			end	

			if timer >= 10 and timer < 50
				summonAura(target, SKINCOLOR_WHITE)
			end
			
			if timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*50, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*4
				playSound(mo.battlen, sfx_hamas2)
			end	
			
			if timer == 50
				for i = 1,72
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = mo.angle+((ANG1*5)*i)
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SILVER
					dust.scale = FRACUNIT*2
				end	
			end
			
			
			if timer == 50
				playSound(mo.battlen, sfx_buff)
				buffStat(target, "mag")
				
			elseif timer == 80
				return true
			end
		end,
}

attackDefs["fortuna"] = {
		name = "Fortuna",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art.\nRaises magic attack and defence\n to all allies by 1 stage",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				local sun = P_SpawnMobj(mo.x,mo.y,mo.z + FRACUNIT*256,MT_DUMMY)
				sun.sprite = SPR_FLAM
				sun.frame = M|FF_FULLBRIGHT
				sun.colorized = true
				sun.color = SKINCOLOR_SUPERGOLD1
				sun.tics = -1
				mo.sun = sun
				playSound(mo.battlen, sfx_s3k9f)
				playSound(mo.battlen, sfx_fortun)
			end
			for tg = 1,#hittargets
				if mo.sun and mo.sun.valid
					local t = hittargets[tg]
					local sun = mo.sun
					local tx = t.x + P_RandomRange(-64,64)*FRACUNIT
					local ty = t.y + P_RandomRange(-64,64)*FRACUNIT
					if P_RandomRange(0,1) and timer <= 60
						local thok = P_SpawnMobj(sun.x,sun.y,sun.z + FRACUNIT*8,MT_DUMMY)
						thok.scale = FRACUNIT/2
						thok.frame = A|FF_FULLBRIGHT
						thok.color = SKINCOLOR_SUPERGOLD2
						thok.tics = 30
						thok.momx = (tx - thok.x)/30
						thok.momy = (ty - thok.y)/30
						thok.momz = (t.z - thok.z)/30
					end
				end
				if timer == 35
					local t = hittargets[tg]
					buffStat(t, "mag")
					buffStat(t, "def")
					BTL_logMessage(targets[1].battlen, "Magic Attack and Defence up!")
				end
				if timer >= 35 and timer < 70
					local t = hittargets[tg]
					summonAura(t, SKINCOLOR_SUPERGOLD2)
				end
			end
			if timer == 35
				playSound(mo.battlen, sfx_heal2)
				playSound(mo.battlen, sfx_buff)
			end
			if timer == 70
				mo.sun.fuse = 20
				mo.sun.destscale = 1
				mo.sun.scalepseed = FRACUNIT/20
				mo.sun = nil
				return true
			end
		end,
}

attackDefs["antistep"] = {
		name = "Anti-Step",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 60,
		statuschance = 60,
		status = COND_SILENCE,
		costtype = CST_SP,
		luckbased = true,	-- use luck instead of agility
		cost = 12,
		desc = "Orbal Art.\nInflicts Silence on 1 enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 10
					playSound(mo.battlen, sfx_antisp)
				end

				if timer <= 35
                    local thok = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    thok.state = S_ANTISTEPART1
                    thok.momz = -3*FRACUNIT 
                    thok.color = SKINCOLOR_RED
                    thok.tics = 35
                    thok.scale = 1
                    thok.destscale = target.scale*(2/2)
					thok.scalespeed = (target.scale*(2/2))/30
                end
				
                if timer <= 35
                    local shit = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shit.sprite = SPR_THOK
                    shit.momz = 0
                        shit.momy = 0
                        shit.momx = 0
                    shit.color = SKINCOLOR_ROSY
                    shit.tics = 2 
                    shit.scale = FRACUNIT*2
					shit.destscale = 1
                    shit.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 35
                    local shits = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shits.sprite = SPR_THOK
                    shits.momz = 0
                        shits.momy = 0
                        shits.momx = 0
                    shits.color = SKINCOLOR_ROSY
                    shits.tics = 35
                    shits.scale = FRACUNIT*2
                        shits.destscale = 1
                        shits.scalespeed = (FRACUNIT*2)/35
                    shits.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 50
					damageObject(target)
				elseif timer == 70
					return true
				end
		end,
}
//LUA is a bitch to make shit work
//You can hear Hajime and Zoruxua screaming in the background
attackDefs["antistepall"] = { 
		name = "Anti-Step All",
		type = ATK_SUPPORT,
		power = 0,
		accuracy = 50,
		statuschance = 50,
		status = COND_SILENCE,
		costtype = CST_SP,
		luckbased = true,	-- use luck instead of agility
		cost = 12,
		desc = "Orbal Art.\nInflicts Silence on all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				for i = 1, #hittargets
					local target = hittargets[i]

					local t = timer - (i-1)*6
					
				if timer == 10
					playSound(mo.battlen, sfx_antisp)
				end

				if timer <= 35
                    local thok = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    thok.state = S_ANTISTEPART1
                    thok.momz = -3*FRACUNIT 
                    thok.color = SKINCOLOR_RED
                    thok.tics = 35
                    thok.scale = 1
                    thok.destscale = target.scale*(2/2)
					thok.scalespeed = (target.scale*(2/2))/30
                end
				
                if timer <= 35
                    local shit = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shit.sprite = SPR_THOK
                    shit.momz = 0
                        shit.momy = 0
                        shit.momx = 0
                    shit.color = SKINCOLOR_ROSY
                    shit.tics = 2 
                    shit.scale = FRACUNIT*2
					shit.destscale = 1
                    shit.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 35
                    local shits = P_SpawnMobj(target.x, target.y, target.z + target.height + 40*FRACUNIT, MT_DUMMY)
                    shits.sprite = SPR_THOK
                    shits.momz = 0
                        shits.momy = 0
                        shits.momx = 0
                    shits.color = SKINCOLOR_ROSY
                    shits.tics = 35
                    shits.scale = FRACUNIT*2
                        shits.destscale = 1
                        shits.scalespeed = (FRACUNIT*2)/35
                    shits.frame = A|FF_FULLBRIGHT
                end
				
				if timer == 50
					damageObject(target)
				elseif timer == 70 + (#hittargets-1)*6
					return true
				end
			end	
		end,
}

attackDefs["judgement_bolt"] = {
		name = "Judgement Bolt",
		type = ATK_ELEC,
		power = 650,
		accuracy = 100,
		costtype = CST_SP,
		status = COND_SHOCK,
		statuschance = 10,
		cost = 32,
		desc = "Orbal Art.\nSevere Elec Damage to a enemy.\nMay Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			
			if timer == 1
				playSound(mo.battlen, sfx_athun2)
			end	

			if timer >= 10 and timer <= 70
				local range = 1024
				local z2 = P_SpawnMobj(target.x + P_RandomRange(-range, range)*mo.scale, target.y + P_RandomRange(-range, range)*mo.scale, target.z, MT_DUMMY)
				z2.state, z2.scale, z2.color = S_TRSPARKLE1	, target.scale*15/4, SKINCOLOR_EMERALD
				z2.destscale = target.scale*3/2
			end	
			
			if timer == 50
				localquake(mo.battlen, FRACUNIT*10, 10)
				playSound(mo.battlen, sfx_litng4)
				playSound(mo.battlen, sfx_judbol)
				S_StartSoundAtVolume(nil,sfx_judbol,70)
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			
			if timer == 110
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			
			if timer >= 110 
			and timer <= 170
			and leveltime%2 == 0
			
				local range = 60
				if timer >= 50
					range = 100
				end
				local s = P_SpawnMobj(target.x + P_RandomRange(-range, range)*mo.scale, target.y + P_RandomRange(-range, range)*mo.scale, target.floorz + P_RandomRange(0, 100)*mo.scale, MT_DUMMY)
				s.state, s.scale, s.color = S_LZIO21, target.scale*15/4, SKINCOLOR_EMERALD
				s.destscale = target.scale*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	
			
			if timer >= 110 
			and timer <= 170
			and leveltime%5 == 0
				lightningblast(target, SKINCOLOR_EMERALD, FRACUNIT*3)
			end	
			
			if timer == 150
				playSound(mo.battlen, sfx_ragblt)
			end	
			
			if timer == 171
				playSound(mo.battlen, sfx_zio3)
				S_StartSoundAtVolume(nil,sfx_zio3,70)
				lightningblast(target, SKINCOLOR_EMERALD, FRACUNIT*3)
				damageObject(target)
				
				for i = 1, 10
					local range = 1024
					local z1 = P_SpawnMobj(target.x + P_RandomRange(-range, range)*mo.scale, target.y + P_RandomRange(-range, range)*mo.scale, target.z, MT_DUMMY)
					z1.state, z1.scale, z1.color = S_LZIO11, target.scale*9/4, SKINCOLOR_EMERALD
					z1.destscale = target.scale
					z1.tics = $ + P_RandomRange(-1, 12)
				end
			
			elseif timer == 199
				return true
			end				
		end,
}

attackDefs["ragna_vortex"] = {
		name = "Ragna Vortex",
		type = ATK_WIND,
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		cost = 24,
		desc = "Orbal Art.\nSevere Wind Damage to a enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_YELLOW, SKINCOLOR_EMERALD, SKINCOLOR_MAGENTA}
			local target = hittargets[1]
			
			if timer == 1
				playSound(mo.battlen, sfx_ragvor)
			end	
			if timer == 5
				local dust = P_SpawnMobj(target.x, target.y, mo.floorz,MT_DUSTDEVIL)
				dust.scale = (FRACUNIT*1)*#hittargets
				mo.nado = dust
			end
			
			if timer > 1
			and timer < 80
			and leveltime%2 == 0
				local s = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*140, MT_DUMMY)
				s.scale = FRACUNIT/4
				s.sprite = SPR_SLAS
				s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
				s.destscale = FRACUNIT*7
				s.scalespeed = FRACUNIT
				s.tics = TICRATE/3
			end			

			if timer == 80
				lightningblast(target, SKINCOLOR_EMERALD, FRACUNIT*3)
			end	
			
			if timer == 82
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			if timer >= 83 and timer <= 170
				local bs = P_SpawnMobj(target.x + P_RandomRange(-120, 144)*FRACUNIT, target.y + P_RandomRange(-120, 144)*FRACUNIT, target.z + P_RandomRange(0, 175)*FRACUNIT, MT_DUMMY)
				bs.state = S_TRSPARKLE1
				bs.color = colors[P_RandomRange(1, #colors)]
				bs.momz = P_RandomRange(-1, 1)*FRACUNIT
				bs.scale = 15/4*FRACUNIT
				bs.destscale = 3/2*FRACUNIT
				localquake(mo.battlen, FRACUNIT*10, 10)
			end	
			
			if timer >= 83 and timer <= 170
				local baseangle = P_RandomRange(1, 360)*ANG1
				local dist = 180
				for i = 0, 24
					local angle = baseangle + i*6*ANG1
					local x, y = target.x + dist*cos(angle), target.y + dist*sin(angle)
					local aura = P_SpawnMobj(x, y, target.z + target.height/4 + i*FRACUNIT*3, MT_DUMMY)
					aura.state = S_AURA1
					aura.angle = angle - ANGLE_90
					aura.color = SKINCOLOR_EMERALD
					aura.momz = P_RandomRange(2, 16)*FRACUNIT
					aura.scale = FRACUNIT*1
					aura.destscale = FRACUNIT*5
					P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
				end	
			end	
			
			if timer == 171
				damageObject(target)
				mo.nado.fuse = 5
				mo.nado = nil
				
			elseif timer == 200
				return true
			end			
		end,			
}
							