if not srb2p return end

freeslot("sfx_jshptb", "S_PHANTRAIDBUDDY", "SPR_JPRD", "sfx_jopht")

states[S_PHANTRAIDBUDDY] = {
	sprite = SPR_JPRD,
	frame = A,
	tics = -1, 
	nextstate = S_PHANTRAIDBUDDY
}

DNG_Abilities["joshua"] = {

    jfunc =     function(p)
                    local mo = p.mo
					P_SetObjectMomZ(mo, FRACUNIT*(-5))
                    p.drawangle = mo.angle
                    mo.momz = 0
                    local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
                    t.color = mo.color
                    P_InstaThrust(mo,mo.angle,(60*FRACUNIT))
                    S_StartSound(p.mo,sfx_spdpad)
					p.powers[pw_flashing] = 2
                end,

        func =        function(p)
                    local mo = p.mo

                    if mo.p_abl
                        if not P_IsObjectOnGround(mo)
                            if (leveltime%2)
                                local g = P_SpawnGhostMobj(mo)
                                g.tics = 4
                                g.colorized = true
                            end
                        else
                            mo.p_abl = false
                        end
                    end
                end,
}


freeslot("SPR_BATJ", "SPR_JCHR", "SPR_JFIR", "SPR_DEFJ", "SPR_JRIP", 
"SPR_JBAL", "sfx_endrn", "sfx_chrdwn", "SPR_PHPN", "sfx_orbald", "sfx_orbal2", 
"SPR_ENFE", "sfx_clokdw", "sfx_duastk", "sfx_flickr", "sfx_solblu", "sfx_helgat", 
"sfx_deaspl", "sfx_calved", "sfx_caledg")

charStats["joshua"] = {

		-- GENERAL

		name = "Joshua",			-- This is only for bots / enemies
		basehp = 59,			-- base HP for level 1
		basesp = 50,
		persona = "joshuaskillset",
		melee_natk = "slash_strike", 
		melee_satk = "phantomraid",
		
		supercolor_start = SKINCOLOR_SUPERJET1,
		
		wep = "twindirks",		-- default weapon.
		weptype = WPT_HANDSONIC,	-- Equippable weapon type(s)

		atk = 40,
		acc = 90,
		crit = 5,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATJ, A, 8, "SPR2_BATJ"},					-- standing
		anim_stand_hurt =	{SPR_BATJ, A, 1, "SPR2_BATJ"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATJ, A, 8, "SPR2_BATJ"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_DEFJ, A, 1, "SPR2_DEFJ"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_JBAL, A, B, C, D, E, F, 2, "SPR2_JBAL"},			-- attacking
		anim_aoa_end =		{SPR_JBAL, F, E, D, C, B, A, 2, "SPR2_JBAL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_JRIP, A, 1, "SPR2_JRIP"},					-- is down
		anim_getup =		{SPR_BATJ, A, 1, "SPR2_BATJ"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, 2, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_JCHR, A, 8, "SPR2_JCHR"},
		anim_evoker_shoot = {SPR_JFIR, A, 8, "SPR2_JFIR"},
		anim_special1 =		{SPR_BATJ, A, 1, "SPR2_BATJ"},
		anim_special2 =		{SPR_PLAY, A, 2, "SPR2_FALL"},
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"},
		
		vfx_summon = {"sfx_josmn1", "sfx_josmn2", "sfx_josmn3", "sfx_josmn4"},
		vfx_skill = {"sfx_joskl1", "sfx_joskl2", "sfx_joskl3", "sfx_joskl4"},
		vfx_item = {"sfx_joitem"},
		vfx_hurt = {"sfx_johrt1", "sfx_johrt2", "sfx_johrt3","sfx_johrt4"},
		vfx_hurtx = {"sfx_joxhrt"},
		vfx_die = {"sfx_jodie1", "sfx_jodie2"},
		vfx_heal = {"sfx_johel1", "sfx_johel2"},
		vfx_healself = {"sfx_johel1"},
		vfx_kill = {"sfx_jokil1", "sfx_jokil2", "sfx_jokil3"},
		vfx_1more = {"sfx_jo1mor", "sfx_jo1mo"},
		vfx_crit = {"sfx_jocrt1", "sfx_jocrt2", "sfx_jocrt3", "sfx_jocrt4"},
		vfx_aoaask = {"sfx_joaoi1", "sfx_joaoi2", "sfx_joaoi3", "sfx_joaoi4"},
		vfx_aoado = {"sfx_joaoa1", "sfx_joaoa2", "sfx_joaoa3", "sfx_joaoa4"},
		vfx_aoarelent = {"sfx_jomis3"},
		vfx_miss = {"sfx_jomis1", "sfx_jomis2", "sfx_jomis3"},
		vfx_dodge = {"sfx_jodog1", "sfx_jodog2"},
		vfx_win = {"sfx_jowin1", "sfx_jowin2", "sfx_jowin3", "sfx_jowin4"},
		vfx_levelup = {"sfx_jowin3", "sfx_jolevl"},
		vfx_tartarus_pit = {"sfx_jodie2"},
		vfx_tartarus_item = {"sfx_joitm2"},
		vfx_tartarus_spring = {"sfx_jospng"},
		vfx_tartarus_spike = {"sfx_johrt1", "sfx_johrt2", "sfx_johrt3","sfx_johrt4"},
		vfx_tartarus_critspike = {"sfx_joxhrt"},
		vfx_tartarus_spikepit = {"sfx_jompit"},

		icon = "H_JOSICO",	-- icon for net select and other menus
		hudbust = "H_JOSBAR",			-- patch to draw on the stat hud
		hudaoa = "H_JOSAOA",	-- patch for all out attack hud
		hudcutin = "JOSH_A",	-- cut in
		aoa_quote = "We will not fail!\nLet's finish them off!",

		tip = "A former Enforcer assassin but now a Senior A-Rank Bracer.With the ARCUS Orbment he uses powerful curse and debuffs orbal arts makes hima good debuffer. Also is the fastest of everyone in the group."
}
	
VFX_freeslotC("joshua")
	
personaList["joshuaskillset"] = {
		-- GENERAL
		name = "Joshua",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk  = 	{SPR_NULL, A, 8},
		startframe = 0,

		strength = 9,
		magic = 8,
		endurance = 9,
		luck = 5,
		agility = 12,
		weak = ATK_BLESS,
		resist = ATK_CURSE|ATK_WIND,
		skills = {
					{bionis and "chaos_brand" or "soul_blur", 1}, {"cleave", 4},
					{"enfeeble", 12}, {"dual_strike", 14, "cleave"}, {bionis and "silver_thorn" or "hell_gate", 15},
					{"phantom_phobia", 16}, {"clock_down", 18},
					{"giant slice", 21, "dual_strike"}, {"orbal_down", 23, "enfeeble"},  
					{bionis and "ascension" or "calvary_edge", 25, bionis and "chaos_brand" or "soul_blur"},
					{"flicker", 26},
					{"tdual_strike", 28, "giant slice"},
					{"phantom_pain", 33, "phantom_phobia"}, {bionis and "avalon_gate" or "death_spiral", 35, bionis and "silver_thorn" or "hell_gate"},
					{"energy_drain", 39}, {"chrono_down", 43, "clock_down"},
					{"tflicker", 47, "flicker"}, {"fatal end", 53, "tdual_strike"},
					{bionis and "luminous_ray" or "calamity_edge", 56, bionis and "ascension" or "calvary_edge"},
					{bionis and "claiomh_solarion" or "death_scream", 61, bionis and "avalon_gate" or "death_spiral"},
					{"sflicker", 65, "tflicker"},
					{"sdual_strike", 66, "fatal end"},
					{"fangflicker", 70, "sflicker"},
					{bionis and "last_disaster" or "abyss_fall", 75, bionis and "luminous_ray" or "calamity_edge"},
					
				},
}


attackDefs["phantomraid"] = {
		name = "Phantom Raid",
		type = ATK_ALMIGHTY,
		power = 300,
		accuracy = 999,
		critical = 20,
		target = TGT_ALLENEMIES,
		cost = CST_HP,
		cost = 300,
		nometronome = true,
		norandom = true,
		technical = COND_FEAR, //Free crits on scared lol
		status = COND_SILENCE, //And lets make it possible to inflict silence
		statuschance = 10,
		desc = "Joshua's S-Craft\nDestroys enemies with copies of himself\n and slashes.May cause Silence",
		hits = 7,
		anim_norepel = true,	-- do not bounce back our ANIMATION
		norepel = true,
		anim = 	function(mo, targets, hittargets, timer)
		local cam = server.P_BattleStatus[mo.battlen].cam
		
			if timer == 1
				ANIM_set(mo, mo.anim_special3, true)
				playSound(mo.battlen, sfx_joaoi3)
				mo.sx = mo.x
				mo.sy = mo.y
				mo.sz = mo.z
				//playSound(mo.battlen, sfx_nopelol)
				//mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				cam.momx = 0
				cam.momy = 0
				cam.momz = 0
			elseif timer == 2
			local cx = mo.x + 256*cos(mo.angle)
			local cy = mo.y + 256*sin(mo.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y) //Looky me..
			elseif timer == 35
				for i = 1,72
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = mo.angle+((ANG1*5)*i)
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SILVER
					dust.scale = FRACUNIT*2
				end
			playSound(mo.battlen, sfx_lydchr)
			elseif timer == 60
				P_SetObjectMomZ(mo,FRACUNIT*100)
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_WHITE
					dust.scale = FRACUNIT*2
				end
			playSound(mo.battlen, sfx_lydchr)
			elseif timer >= 80
			and timer < 115
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
				if timer == 80
					playSound(mo.battlen, sfx_jopht)
					local cx = mo.x + 256*cos(mo.angle)
					local cy = mo.y + 256*sin(mo.angle)
					P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
					playSound(mo.battlen, sfx_monton)
				end
			elseif timer >= 115
			and timer < 150
				if timer == 115
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 1, 10)
						end
					end
					playSound(mo.battlen, sfx_cutlyd)
					playSound(mo.battlen, sfx_appear)
					playSound(mo.battlen, sfx_appear)
					local cx = mo.x + 384*cos(mo.angle)
					local cy = mo.y + 384*sin(mo.angle)
					P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
					local lg = P_SpawnMobj(mo.x+128*cos((mo.angle)+ANGLE_45),mo.y+128*sin((mo.angle)+ANGLE_45), mo.z, MT_THOK)
					//lg.state = S_PHANTRAIDBUDDY
					lg.frame = A
					lg.tics = 9999
					lg.sprite = SPR_JPRD
					lg.color = mo.color
					lg.angle = mo.angle
					mo.lg = lg
					local rg = P_SpawnMobj(mo.x+128*cos((mo.angle)+ANGLE_315),mo.y+128*sin((mo.angle)+ANGLE_315),mo.z, MT_THOK)
					//rg.state = S_PHANTRAIDBUDDY
					rg.sprite = SPR_JPRD
					rg.tics = 9999
					rg.frame = A
					rg.color = mo.color
					rg.angle = mo.angle
					mo.rg = rg
				end
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			P_TeleportMove(mo.lg,mo.x-128*cos((mo.angle)+ANGLE_45),mo.y-128*sin((mo.angle)+ANGLE_45),mo.z)
			P_TeleportMove(mo.rg,mo.x-128*cos((mo.angle)+ANGLE_315),mo.y-128*sin((mo.angle)+ANGLE_315),mo.z)
			elseif timer == 150
			P_TeleportMove(mo,mo.sx,mo.sy,mo.sz)
			ANIM_set(mo, mo.anim_special2, true)
			end
			for i = 1,#hittargets
				local target = hittargets[i]
				
				
				local time = timer - (i-1)*25
				if time >= 150
				and time < 175
					if time == 150
					mo.lg.frame = B
					mo.rg.frame = B
					P_TeleportMove(mo,mo.sx,mo.sy,mo.sz)
					mo.momx = 0
					mo.momy = 0
					mo.momz = 0
					local cx = target.x + 256*cos(target.angle)
					local cy = target.y + 256*sin(target.angle)
					P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*16)
					server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
					mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
					elseif time == 155
					P_InstaThrust(mo,mo.angle,128*FRACUNIT)
					elseif time == 158
					createSplat(mo)
					playSound(mo.battlen, sfx_slash)
					damageObject(target)
					end
					
				mo.lg.angle = mo.angle
				mo.rg.angle = mo.angle
				P_TeleportMove(mo.lg,mo.x-128*cos((mo.angle)+ANGLE_45),mo.y-128*sin((mo.angle)+ANGLE_45),mo.z)
				P_TeleportMove(mo.rg,mo.x-128*cos((mo.angle)+ANGLE_315),mo.y-128*sin((mo.angle)+ANGLE_315),mo.z)
				end
			end
			local atime = timer - (#hittargets-1)*25
			if atime == 175
			mo.lg.angle = mo.angle
			mo.rg.angle = mo.angle
			P_TeleportMove(mo,mo.sx,mo.sy,mo.sz + FRACUNIT*1000)
			P_TeleportMove(mo.lg,mo.x-128*cos((mo.angle)+ANGLE_45),mo.y-128*sin((mo.angle)+ANGLE_45),mo.z)
			P_TeleportMove(mo.rg,mo.x-128*cos((mo.angle)+ANGLE_315),mo.y-128*sin((mo.angle)+ANGLE_315),mo.z)
			local cx = mo.x + 256*cos(mo.angle)
			local cy = mo.y + 256*sin(mo.angle)
			P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			elseif atime >= 176
			and atime < 211
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
				if atime == 176
				mo.rg.momx = (mo.x - mo.rg.x)/35
				mo.rg.momy = (mo.y - mo.rg.y)/35
				mo.rg.momz = (mo.z - mo.rg.z)/35
				mo.lg.momx = (mo.x - mo.lg.x)/35
				mo.lg.momy = (mo.y - mo.lg.y)/35
				mo.lg.momz = (mo.z - mo.lg.z)/35
				mo.rg.tics = 35
				mo.lg.tics = 35
				elseif atime == 210
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
					for i = 1,72
						local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
						dust.angle = mo.angle+((ANG1*5)*i)
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_WHITE
						dust.scale = FRACUNIT*3
					end
					playSound(mo.battlen, sfx_buff)
				end
			elseif atime == 211
			playSound(mo.battlen, sfx_jshptb)
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			local cx = mo.x + 256*cos(mo.angle+ANGLE_180)
			local cy = mo.y + 256*sin(mo.angle+ANGLE_180)
			P_TeleportMove(cam, cx, cy, mo.sz + FRACUNIT*16)
			server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
			mo.lg = nil
			mo.rg = nil
			end
			for i = 1,5
				if atime == 215 + 20*(i-1)
					for bruh = 1,#hittargets
						local target = hittargets[bruh]
						damageObject(target)
						playSound(mo.battlen, sfx_slash)
						createSplat(mo)
					end
				end
			end
			if atime >= 215
			and atime < 295
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
			local rnd = P_RandomRange(1,#hittargets) //Stolen moment lmao
			local rtarget = hittargets[rnd]
			local s = P_SpawnMobj(rtarget.x + FRACUNIT*P_RandomRange(-128,128), rtarget.y + FRACUNIT*P_RandomRange(-128,128), rtarget.z + FRACUNIT*P_RandomRange(-128,128), MT_DUMMY)
			s.state = S_SLASHING_2_1
			s.color = mo.color
			s.scale = FRACUNIT*3
			s.rollangle = P_RandomRange(0, 359)*ANG1
			local b = P_SpawnMobj(rtarget.x, rtarget.y, rtarget.z+20*FRACUNIT, MT_DUMMY)
			b.momx = P_RandomRange(-35, 35)*FRACUNIT
			b.momy = P_RandomRange(-35, 35)*FRACUNIT
			b.momz = P_RandomRange(-35, 35)*FRACUNIT
			b.color = SKINCOLOR_RED
			b.frame = A|FF_FULLBRIGHT
			b.scale = FRACUNIT/2
			b.destscale = FRACUNIT/12
			b.tics = 35
			
			elseif atime >= 310
			and atime < 345
			mo.momx = 0
			mo.momy = 0
			mo.momz = 0
				for bruh = 1,#hittargets
					local target = hittargets[bruh]
					if atime == 310
						local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						s.state = S_SLASHING_2_1
						s.color = mo.color
						s.scale = FRACUNIT*6
					elseif atime == 325
					playSound(mo.battlen, sfx_slash)
					createSplat(mo)
					damageObject(target)
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_RED
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
						for k,v in ipairs(mo.allies)
							if v and v.control and v.control.valid
								P_FlashPal(v.control, 4, 5)
							end
						end
						P_TeleportMove(mo,mo.sx,mo.sy,mo.sz + 128*FRACUNIT)
					ANIM_set(mo, mo.anim_aoa_end, true)
					mo.angle = R_PointToAngle2(mo.x, mo.y, cam.x, cam.y)
					end
				end
			elseif atime == 345
				mo.sx = nil
				mo.sy = nil
				mo.sz = nil
			elseif atime == 360
			mo.angle = $1+ANGLE_180
			elseif atime == 365
				return true
			end
			if atime > 325
			and atime < 365
			and P_IsObjectOnGround(mo)
			ANIM_set(mo, mo.anim_stand, true)
			end
		end,
}

attackDefs["slash_strike"] = {
		name = "Slash Strike",
		type = ATK_SLASH,
		power = 60,
		accuracy = 90,
		critical = 2,
		target = TGT_ENEMY,
		cost = CST_HP,
		cost = 0,
		desc = "Slashes the enemy with a assassin\nslash.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		physical = true,	-- don't play the summoning anim for phys attacks, duh
		anim = function(mo, targets, hittargets, timer)

			local target = hittargets[1]

			if timer == 1
				ANIM_set(mo, mo.anim_special2)
				local g = P_SpawnGhostMobj(mo)
				g.colorized = true

				local cx = target.x + 168*cos(target.angle + ANG1*20)
				local cy = target.y + 168*sin(target.angle + ANG1*20)
				CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				S_StartSound(mo, sfx_zoom)

			elseif R_PointToDist2(mo.x, mo.y, target.x, target.y) > FRACUNIT*64
			and mo.k_savetime == nil
				local ang = R_PointToAngle2(mo.x, mo.y, target.x, target.y)
				mo.angle = ang
				if R_PointToDist2(mo.x, mo.y, target.x, target.y) < FRACUNIT*192
					ANIM_set(mo, mo.anim_downloop)
					P_InstaThrust(mo, ang, FRACUNIT*64)
					if leveltime & 1
						local g = P_SpawnGhostMobj(mo)
						g.colorized = true
					end
				else
					P_InstaThrust(mo, ang, FRACUNIT*32)
				end
			elseif mo.k_savetime == nil	-- attack connects

				mo.k_savetime = timer

				local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)
				s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3
				playSound(mo.battlen, sfx_slash)

			elseif timer == mo.k_savetime + 2

				damageObject(target)
				playSound(mo.battlen, sfx_bexpld)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				localquake(mo.battlen, FRACUNIT*10, 10)
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_RED
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*8
				s.scalespeed = FRACUNIT/2
				s.color = SKINCOLOR_WHITE

				s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = G|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.tics = TICRATE/2
				s.fuse = s.tics
				s.destscale = FRACUNIT*10
				s.scalespeed = FRACUNIT/4
				s.color = SKINCOLOR_WHITE
			elseif timer == mo.k_savetime + TICRATE

				mo.k_savetime = nil
				return true
			end
		end,
}

attackDefs["soul_blur"] = {
		name = "Soul Blur",
		type = ATK_CURSE,
		power = 75,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		desc = "Orbal Art\nLight curse damage to a enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				S_StartSound(nil,sfx_solblu)
			end	
			
			if timer < 35
				summonAura(mo, SKINCOLOR_PURPLE) //why he
			end
			if timer == 20
			or timer == 25
			or timer == 30
			or timer == 35
			or timer == 40
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z + 32*FRACUNIT, MT_DUMMY)	
				if P_RandomRange(0,1)
					thok.color = SKINCOLOR_JET
				else
					thok.color = SKINCOLOR_PURPLE
				end
				thok.frame = A|FF_FULLBRIGHT
				thok.flags2 = $|MF2_SPLAT
				thok.tics = 10
				thok.scale = mo.scale*2
				thok.momx = (target.x - thok.x)/10
				thok.momy = (target.y - thok.y)/10
				thok.momz = ((target.z + 32*FRACUNIT) - thok.z)/10
				
				S_StartSound(nil,sfx_s3k81)
			end
			if timer == 20
			or timer == 25
			or timer == 30
			or timer == 35
			or timer == 40
				if timer == 40
					damageObject(target)
					S_StartSound(nil,sfx_hit)
				else
					S_StartSound(nil,sfx_slash)
				end
			end
			if timer == 80
				return true
			end
		end,
}

attackDefs["hell_gate"] = {
		name = "Hell Gate",
		type = ATK_CURSE,
		power = 75,
		accuracy = 90,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art\nLight curse damage to all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for ht = 1,#hittargets
				local target = hittargets[ht]
				
				if timer >= 1 and timer <= 74
					for i = 1,3
						local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
						thok.flags = MF_NOBLOCKMAP
						thok.color = SKINCOLOR_PURPLE
						if timer%2 then thok.color = SKINCOLOR_JET end
						thok.frame = A
						thok.tics = 35
						thok.scale = FRACUNIT/1
						thok.scalespeed = FRACUNIT/32
						thok.destscale = 1
						thok.momz = P_RandomRange(5, 10)*FRACUNIT
						thok.momx = P_RandomRange(-6, 6)*FRACUNIT
						thok.momy = P_RandomRange(-6, 6)*FRACUNIT
					end	
				end

				
				if timer > 25
				and timer <= 75
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					if P_RandomRange(0,1)
						thok.color = SKINCOLOR_JET
					else
						thok.color = SKINCOLOR_PURPLE
					end
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 35
					thok.scale = FRACUNIT*1
					thok.destscale = 1
					thok.scalespeed = FRACUNIT/105
					thok.momx = P_RandomRange(-5,5)*FRACUNIT
					thok.momy = P_RandomRange(-5,5)*FRACUNIT
					thok.momz = P_RandomRange(10,30)*FRACUNIT
				end
				if timer == 75
					damageObject(target)
				end
			end
			
			if timer == 1
				S_StartSound(nil,sfx_helgat)
			end	
	
			if timer == 25
				S_StartSound(nil,sfx_s3k9b)
			end
			if timer == 75
				S_StartSound(nil,sfx_slash)
			end
			if timer == 110
				return true
			end
		end,
}

attackDefs["calvary_edge"] = {
		name = "Calvary Edge",
		type = ATK_CURSE,
		power = 170,
		accuracy = 95,
		costtype = CST_SP,
		cost = 8,
		desc = "Orbal Art\nMedium curse damage to a enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				local thok = P_SpawnMobj(target.x, target.y, target.z + FRACUNIT*100, MT_DUMMY)	
				thok.sprite = SPR_USPK
				thok.frame = A|FF_FULLBRIGHT
				thok.colorized = true
				thok.color = SKINCOLOR_NEON
				thok.tics = 130
				thok.scale = 1
				thok.destscale = target.scale * 7
				thok.scalespeed = (target.scale * 10)/10
				S_StartSound(nil,sfx_calved)
				S_StartSound(nil,sfx_calved)
			end
			if timer == 10
				S_StartSound(nil,sfx_bsnipe)//fukin idk
				--not curse enough, blow shit up
				for i = 1,75
					local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
					if (i%2)
						thok.color = SKINCOLOR_JET
					else
						thok.color = SKINCOLOR_PURPLE
					end
					thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 105
					thok.scale = mo.scale/2
					thok.destscale = 1
					thok.scalespeed = (mo.scale/2)/105
					thok.momx = P_RandomRange(-15,15)*FRACUNIT
					thok.momy = P_RandomRange(-15,15)*FRACUNIT
					thok.momz = P_RandomRange(5,15)*FRACUNIT
				end
			end
			
			if timer == 49
				for k,v in ipairs(mo.allies)
					if v and v.control and v.control.valid
						P_FlashPal(v.control, 5, 5)
					end
				end
			end	
			
			if timer >= 50 and timer <= 130
			and (timer%5) == 0
				for i = 1, #hittargets
					local t = hittargets[1]
					local s = P_SpawnMobj(t.x + P_RandomRange(-60, 60)<<FRACBITS, t.y + P_RandomRange(-60, 60)<<FRACBITS, t.z + P_RandomRange(0, 60)<<FRACBITS, MT_DUMMY)
					s.color = SKINCOLOR_MAGENTA
					s.state = S_MEGISTAR1
					s.scale = $*2 + P_RandomRange(0, 65535)
				end	
			end	
			
			if timer >= 50 and timer <= 130
				for i = 1, 2
					local m = P_SpawnMobj(target.x + P_RandomRange(-64, 64)*FRACUNIT, target.y  + P_RandomRange(-64, 64)*FRACUNIT, target.z, MT_DUMMY)
					m.tics = -1
					m.color = SKINCOLOR_PURPLE
					m.frame = FF_FULLBRIGHT
					m.scale = FRACUNIT*2
					m.momz = FRACUNIT*64
					m.fuse = TICRATE
					m.sprite = SPR_THOK
				end	
			end
			
			if timer == 131
				damageObject(target)
				playSound(mo.battlen, sfx_s3k83)
			end	
			
			if timer == 150
				//had a good idea then srb2 happened
				return true
			end
		end,
}

attackDefs["death_spiral"] = {
		name = "Death Spiral",
		type = ATK_CURSE,
		power = 170,
		accuracy = 90,
		costtype = CST_SP,
		cost = 16,
		desc = "Orbal Art\nMedium curse damage to all enemies.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for hit = 1,#hittargets
				local target = hittargets[hit]
				
				if timer == 18
					target.rotspike = {}
					for i = 1,4
						local tgtx = target.x + 72*cos(target.angle + (ANGLE_90*i))
						local tgty = target.y + 72*sin(target.angle + (ANGLE_90*i))
						local thok = P_SpawnMobj(tgtx, tgty, target.floorz, MT_DUMMY)	
						thok.sprite = SPR_USPK
						thok.frame = A|FF_FULLBRIGHT
						thok.colorized = true
						thok.color = SKINCOLOR_CRIMSON
						thok.tics = -1
						thok.scale = 1
						thok.destscale = target.scale * 2
						thok.scalespeed = (target.scale * 2)/5
						target.rotspike[i] = thok
					end
				end
				if timer > 35
				and timer <= 118
					for i = 1,4
						local s = target.rotspike[i]
						local tgtx = target.x + (118 - timer)*cos((target.angle + (ANGLE_90*i)) + (ANG10*timer))
						local tgty = target.y + (118 - timer)*sin((target.angle + (ANGLE_90*i)) + (ANG10*timer))
						P_TeleportMove(s,tgtx,tgty,target.floorz)
						if timer == 36
							s.destscale = target.scale * 10
							s.scalespeed = ((target.scale * 10) - (target.scale * 2))/70
						end
					end
					summonAura(target, SKINCOLOR_NEON)
				end
				if timer == 118
					for i = 1,4
						local s = target.rotspike[i]
						s.fuse = 2
					end
					for i = 1,40
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						if (i%2)
							thok.color = SKINCOLOR_JET
						else
							thok.color = SKINCOLOR_PURPLE
						end
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 105
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/105
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
					damageObject(target)
				end
				if timer == 145
					target.rotspike = nil
					return true
				end
			end
			//Sound test!
			if timer == 1
				S_StartSound(nil,sfx_deaspl)
				S_StartSound(nil,sfx_deaspl)
			end
			
			if timer == 18
				S_StartSound(nil,sfx_spkdth)
			end
			
			if timer == 36
				S_StartSound(nil,sfx_debuff)
			end
			if timer == 118
				S_StartSound(nil,sfx_bsnipe)
			end
			if timer == 150
				return true //this is just a failsafe
			end
		end,
}

attackDefs["calamity_edge"] = {
		name = "Calamity Edge",
		type = ATK_CURSE,
		power = 400,
		accuracy = 95,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art\nHeavy curse damage to a enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local bitch = targets[1]//bup
			if timer == 1
				playSound(mo.battlen, sfx_caledg)
			end
			if timer < 50
				local rangle = P_RandomRange(0, 359)
				local cx = mo.x + 128*cos(mo.angle + ANG1*(rangle))
				local cy = mo.y + 128*sin(mo.angle + ANG1*(rangle))
					
				local thok = P_SpawnMobj(cx, cy, mo.z, MT_DUMMY)	
				thok.color = SKINCOLOR_JET
				thok.frame = A|FF_FULLBRIGHT
				thok.tics = 15
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT/2)/15
				thok.scale = FRACUNIT/2
				thok.momx = (mo.x - thok.x)/15
				thok.momy = (mo.y - thok.y)/15
				thok.momz = (mo.z - thok.z)/15
			end //I will never not stop borrowing from myself
			if timer == 50
				playSound(mo.battlen, sfx_s3k81)
				local thok = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)	
				thok.color = SKINCOLOR_JET
				thok.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(mo.x,mo.y,bitch.x,bitch.y)
				thok.tics = 20
				thok.scale = mo.scale*2
				thok.momx = (bitch.x - thok.x)/20
				thok.momy = (bitch.y - thok.y)/20
				thok.momz = (bitch.z - thok.z)/20
			end
			if timer == 75 and target == bitch
				damageObject(target)
				playSound(mo.battlen, sfx_s3k4e)
				if target.damagestate ~= DMG_MISS
					for i = 1,50
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						thok.color = SKINCOLOR_JET
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 105
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/105
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
				end
			elseif timer == 75 and target ~= bitch
				local thok = P_SpawnMobj(bitch.x, bitch.y, bitch.z, MT_DUMMY)	
				playSound(mo.battlen, sfx_cdpcm9)
				thok.color = SKINCOLOR_JET
				thok.frame = A|FF_FULLBRIGHT|FF_PAPERSPRITE
				thok.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				thok.tics = 10
				thok.scale = mo.scale*2
				thok.momx = (target.x - thok.x)/10
				thok.momy = (target.y - thok.y)/10
				thok.momz = (target.z - thok.z)/10
			end
			if timer == 80 and target ~= bitch
				damageObject(target)
				playSound(mo.battlen, sfx_s3k4e)
				if target.damagestate ~= DMG_MISS
					for i = 1,50
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						thok.color = SKINCOLOR_JET
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 105
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/105
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
				end
			end
			if timer == 105 and target == bitch
				return true
			end
			if timer == 120 
				return true
			end
		end,
}

attackDefs["death_scream"] = {
	name = "Death Scream",
	type = ATK_CURSE,
	power = 400,
	accuracy = 90,
	costtype = CST_SP,
	cost = 24,
	desc = "Orbal Art\nHeavy curse damage to all enemies.",
	target = TGT_ALLENEMIES,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		if timer == 10
			S_StartSound(nil,sfx_crest)
		end
		
		if timer >= 10 and timer <= 55
			localquake(mo.battlen, FRACUNIT*10, 10)
		end	
		
		if timer >= 10 and timer <= 55
			for i = 1,3
				local thok = P_SpawnMobj(avgx + P_RandomRange(-120, 120)*FRACUNIT, avgy + P_RandomRange(-120, 120)*FRACUNIT, mo.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_PURPLE
				if timer%2 then thok.color = SKINCOLOR_JET end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT*1
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 7)*FRACUNIT
				thok.momx = P_RandomRange(-20, 20)*FRACUNIT
				thok.momy = P_RandomRange(-20, 20)*FRACUNIT
			end
		end
		
		if timer == 30
			S_StartSound(nil,sfx_helgat)
		end
		
		if timer > 55 and timer < 80
			local rcol = {SKINCOLOR_PURPLE,SKINCOLOR_NEON,SKINCOLOR_VIOLET,SKINCOLOR_BLACK,SKINCOLOR_MAGENTA}			
				for i = 1,10
					local thok = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)	
					if (i%2)
						thok.color = SKINCOLOR_JET
					else
						thok.color = SKINCOLOR_PURPLE
					end
						thok.frame = A|FF_FULLBRIGHT
					thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
					thok.tics = 105
					thok.scale = mo.scale/2
					thok.destscale = 1
					thok.scalespeed = (mo.scale/2)/105
					thok.momx = P_RandomRange(-15,15)*FRACUNIT
					thok.momy = P_RandomRange(-15,15)*FRACUNIT
					thok.momz = P_RandomRange(5,15)*FRACUNIT
				end	
				
			if leveltime%2 == 0
				local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
				t.fuse = TICRATE/2
				t.sprite = SPR_MUDO
				t.tics = -1
				t.frame = C|TR_TRANS10
				t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
				t.scale = FRACUNIT/3
				t.destscale = FRACUNIT*3
				t.scalespeed = FRACUNIT/6
			end

			if leveltime%3 == 0
				local caman = R_PointToAngle(avgx, avgy)
				local t = P_SpawnMobj(avgx + 2*cos(caman), avgy + 2*cos(caman), mo.z, MT_THOK)
				t.fuse = TICRATE/2
				t.sprite = SPR_MUDO
				t.tics = -1
				t.frame = D|TR_TRANS10
				t.color = SKINCOLOR_PURPLE
				t.scale = FRACUNIT/3
				t.destscale = FRACUNIT*3
				t.scalespeed = FRACUNIT/4
			end
		end


		if timer == 60
			for i = 1,#hittargets
				local target = hittargets[i]
				damageObject(target)
			end	
		end	
		
		if timer == 100
			return true
		end
	end,
}

attackDefs["energy_drain"] = {
		name = "Energy Drain",
		type = ATK_CURSE,
		power = 270,
		accuracy = 999,
		costtype = CST_SP,
		cost = 16,
		desc = "Orbal Art.\nDrains a Enemy's HP",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 24
				playSound(mo.battlen, sfx_endrn)
			end
			if timer == 25
			and target == mo
				return true
			end
			if timer == 10 and target ~= mo
				damageObject(target)
				if target.damagestate ~= DMG_MISS		-- make sure we landed the attack
				and target.damagestate ~= DMG_BLOCK
				and target.damagestate ~= DMG_DRAIN
					playSound(mo.battlen, sfx_bufu6)
					mo.hpsucc = true
					mo.buf_damage = target.damagetaken
				end
			end
			
			if timer == 35 and not mo.hpsucc
				mo.hpsucc = nil
				return true
			end
			if timer < 60 and mo.hpsucc
				local rx = target.x + P_RandomRange(-32,32)*FRACUNIT
				local ry = target.y + P_RandomRange(-32,32)*FRACUNIT
				local rz = target.z + P_RandomRange(0,32)*FRACUNIT
				local thok = P_SpawnMobj(rx,ry,rz,MT_THOK)
					thok.sprite = SPR_THOK
					thok.frame = A|FF_FULLBRIGHT
					thok.color = SKINCOLOR_CYAN
					thok.tics = 15
					thok.momx = (mo.x - thok.x)/15
					thok.momy = (mo.y - thok.y)/15
					thok.momz = ((mo.z + FRACUNIT*32) - thok.z)/15
			end
			if timer == 70
			and target ~= mo
				mo.atk_attacker = mo
				playSound(mo.battlen, sfx_lsheal)
				damageObject(mo, -mo.buf_damage, DMG_NORMAL)
			end
			if timer == 100
				mo.buf_damage = nil
				mo.hpsucc = nil
				return true
			end
		end,
	}

attackDefs["clock_down"] = {
		name = "Clock Down",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nLowers agility to a enemy \nby 1 stage",
		target = TGT_ENEMY,
		debuff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["agi"][1] <= -75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
	anim = function(mo, targets, hittargets, timer)
		local targ = hittargets[1]
		local clockupcolors = {SKINCOLOR_AETHER, SKINCOLOR_SLATE, SKINCOLOR_BLUEBELL}
		
		if timer == 1
			playSound(mo.battlen, sfx_clokdw)
		end
		
		
		if timer == 1
			mo.circleMobjs = {}
			mo.smallHand = {}
			mo.longHand = {}
		end

		if timer == 100
			local thok = P_SpawnMobj(targ.x, targ.y, targ.z, MT_THOK)
			thok.destscale = 5*FRACUNIT
			thok.color = SKINCOLOR_BLUEBELL
			thok.tics = 35
			thok.fuse = 50
		end

		if timer >= 155
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then P_RemoveMobj(v) end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then P_RemoveMobj(v) end
			end
			
			mo.circleMobjs = nil
			mo.smallHand = nil
			mo.longHand = nil
			return true
		end
		
		if timer == 2
			for i = -18, 18
				local x = FixedMul(100*cos(targ.angle+ANGLE_90), cos(i*ANG10))
				local y = FixedMul(100*sin(targ.angle+ANGLE_90), cos(i*ANG10))
				local z = (50*FRACUNIT) + (100*sin(i*ANG10))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/2
				thok.color = SKINCOLOR_BLUEBELL

				table.insert(mo.circleMobjs, thok)
			end

			for i = 1, 10
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/3
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.longHand, thok)
			end

			for i = 1, 6
				local x = FixedMul((i*10)*cos(targ.angle+ANGLE_90), cos(ANGLE_90))
				local y = FixedMul((i*10)*sin(targ.angle+ANGLE_90), cos(ANGLE_90))
				local z = (50*FRACUNIT) + ((i*10)*sin(ANGLE_90))

				local thok = P_SpawnMobj(targ.x+x, targ.y+y, targ.z+z, MT_DUMMY)
				thok.tics = 150
				thok.fuse = 150
				thok.scale = FRACUNIT/4
				thok.color = SKINCOLOR_WHITE
				thok.vang = ANGLE_90
				thok.keepDist = (i*10)
	
				table.insert(mo.smallHand, thok)
			end
		end

		local trans = {FF_TRANS90, FF_TRANS80, FF_TRANS70, FF_TRANS60, FF_TRANS50, FF_TRANS40, FF_TRANS30, FF_TRANS20, FF_TRANS10}
		if timer >= 3 and timer <= 12
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[timer-2] or FF_TRANS10)|A end
			end
		end

		if timer >= 141 and timer <= 150
			for k,v in ipairs(mo.circleMobjs)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.smallHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end

			for k,v in ipairs(mo.longHand)
				if v and v.valid then v.frame = (trans[150-timer] or FF_TRANS10)|A end
			end
		end

		if timer >= 30
			if not (timer%10)
				local ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT/5
				ol.frame = B|FF_FULLBRIGHT
				ol.tics = 20

				ol = P_SpawnMobj(targ.x, targ.y, targ.z, MT_DUMMY)
				ol.sprite = SPR_NTHK
				ol.color = clockupcolors[P_RandomRange(1, #clockupcolors)]
				ol.scale = 1
				ol.destscale = FRACUNIT*32
				ol.scalespeed = FRACUNIT
				ol.frame = B|FF_FULLBRIGHT|TR_TRANS50
				ol.tics = 8
			end

			if timer <= 40
				if not (timer%20) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2
		
						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 50
				if not (timer%15) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 60
				if not (timer%10) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 70
				if not (timer%7) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			elseif timer <= 170
				if not (timer%5) then playSound(mo.battlen, sfx_ctic) end

				for k,v in ipairs(mo.smallHand)
					if v and v.valid
						v.vang = $+ANG2

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end

				for k,v in ipairs(mo.longHand)
					if v and v.valid
						v.vang = $+(ANG1/3)

						local x = targ.x + (FixedMul(v.keepDist*cos(targ.angle+ANGLE_90), cos(v.vang)))
						local y = targ.y + (FixedMul(v.keepDist*sin(targ.angle+ANGLE_90), cos(v.vang)))
						local z = targ.z + (50*FRACUNIT) + v.keepDist*sin(v.vang)
						P_TeleportMove(v, x, y, z)
					end
				end
			end	
			if timer == 100
				playSound(mo.battlen, sfx_debuff)
				buffStat(targ, "agi", -25)
			end
		end
	end,
}
attackDefs["orbal_down"] = { --Jenna's idea for the this which is poggers
		name = "Orbal Down",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 17,
		desc = "Orbal Art.\nLowers defence to all enemies\nby 1 stage.",
		target = TGT_ALLENEMIES,
		debuff = true,
		anim = function(mo, targets, hittargets, timer)

				local avgx = 0
				local avgy = 0
				for i = 1, #hittargets do
					avgx = $ + hittargets[i].x/FRACUNIT
					avgy = $ + hittargets[i].y/FRACUNIT
				end
				avgx = $ / #hittargets *FRACUNIT
				avgy = $ / #hittargets *FRACUNIT
				-- average position of the enemies
				
				if timer == 10
					local orbal = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*10, MT_DUMMY)			
					orbal.state = S_ORBALEVOKER3
					orbal.scale = FRACUNIT*3
				end	
						
				
				if timer == 10
					playSound(mo.battlen, sfx_orbald)
				end

				if timer >= 20


					local baseangle = P_RandomRange(1, 360)*ANG1
					local dist = 256
					for i = 0, 24
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z + mo.height/4 + i*FRACUNIT*3, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_COBALT
						aura.momz = P_RandomRange(4, 16)*FRACUNIT
						aura.scale = FRACUNIT*3
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(3, 9))
					end
				end

				if timer == 90
					mo.hcard = nil
					mo.hcard2 = nil

					playSound(mo.battlen, sfx_orbal2)
					playSound(mo.battlen, sfx_debuff)

					for k,v in ipairs(hittargets)
						buffStat(v, "def", -25)
					end
				end

				if timer >= 90
				and timer <= 150
					local baseangle = P_RandomRange(1, 380)*ANG1
					local dist = 256
					for i = 1, 16
						local angle = baseangle + i*6*ANG1
						local x, y = avgx + dist*cos(angle), avgy + dist*sin(angle)

						local aura = P_SpawnMobj(x, y, mo.z + mo.height/5 + i*FRACUNIT*4, MT_DUMMY)
						aura.state = S_AURA1
						--if not aura or not aura.valid continue end
						aura.angle = angle - ANGLE_90
						aura.color = SKINCOLOR_BLUE
						aura.momz = P_RandomRange(6, 16)*FRACUNIT
						aura.scale = FRACUNIT*3
						aura.destscale = FRACUNIT*5
						P_InstaThrust(aura, angle, FRACUNIT*P_RandomRange(2, 2))
					end
				end

				if timer == 165
					return true
				end
		end,
	}

attackDefs["enfeeble"] = {
		name = "Enfeeble",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nLowers defence to a enemy \nby 1 stage",
		target = TGT_ENEMY,
		debuff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["def"][1] <= -75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				playSound(mo.battlen, sfx_clokdw)
			end
			
			if timer == 5
				local m = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				m.sprite = SPR_ENFE
				m.color = SKINCOLOR_MAGENTA
				m.scale = FRACUNIT*1
				m.flags2 = $|MF2_SPLAT
				m.flags = MF_NOBLOCKMAP
				m.renderflags = $|RF_NOCOLORMAPS
				m.tics = 90
				
			
			elseif timer == 5
				playSound(mo.battlen, sfx_frei1)

			elseif timer > 5
			and timer < 100

				if leveltime & 1
					for i = 1, 2

						local s = P_SpawnMobj(target.x, target.y, target.z + mo.scale*32, MT_DUMMY)
						if i == 1
							s.z = $ - mo.scale*32
						else
							s.z = $ + mo.scale*100
						end

						s.sprite = SPR_SLAS
						s.frame = K+(i-1) | FF_FULLBRIGHT | TR_TRANS30
						s.color = SKINCOLOR_BLUEBELL
						s.scale = FRACUNIT/8
						s.destscale = FRACUNIT*3
						s.scalespeed = FRACUNIT/2
						s.tics = TICRATE/2

						s.momx = P_RandomRange(-2, 2)*FRACUNIT
						s.momy = P_RandomRange(-2, 2)*FRACUNIT
						s.momz = P_RandomRange(-2, 2)*FRACUNIT

					end
				end
			end	

				
			if timer == 100
				playSound(mo.battlen, sfx_debuff)
				buffStat(target, "def", -25)
				local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_WHITE
				dbuff.scale = FRACUNIT*5/2
			end
			
			if timer == 100
				return true
			end
		end,
}

attackDefs["phantom_phobia"] = {
		name = "Phantom Phobia",
		type = ATK_SUPPORT,
		accuracy = 40,
		costtype = CST_SP,
		cost = 6,
		desc = "Orbal Art.\nLowers attack to a enemy \nby 1 stage.",
		target = TGT_ENEMY,
		debuff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["atk"][1] <= -75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 25
				playSound(mo.battlen, sfx_eih4)
			end
			
			if timer >= 20 and timer <= 50
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_MAGENTA
					if timer%2 then thok.color = SKINCOLOR_WHITE end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			elseif timer >= 51 and timer <= 60
				if timer == 52
					for i = 1,16
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						if i%2 then thok.color = SKINCOLOR_MAGENTA else thok.color = SKINCOLOR_WHITE end
						thok.frame = A
						thok.destscale = 1
						thok.tics = 30
						thok.scalespeed = FRACUNIT/6
						thok.angle = ANGLE_22h*(i-1)
						P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
					end
				end
				for i = 1,8
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.color = SKINCOLOR_MAGENTA
					if timer%2 then thok.color = SKINCOLOR_WHITE end
					if i == 1
						thok.color = SKINCOLOR_WHITE
					end
					thok.frame = A
					thok.tics = 35
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(15, 30)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			end
			
			if timer == 20
				playSound(mo.battlen, sfx_debuff)
				local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				orb.sprite = SPR_PHPN
				orb.frame = A|TR_TRANS30
				orb.scale = FRACUNIT*2
				orb.scalespeed = FRACUNIT/32
				orb.destscale = FRACUNIT/6
				orb.tics = 2*TICRATE-15
				orb.color = SKINCOLOR_WHITE

			elseif timer == 50
				buffStat(target, "atk", -25)	-- negative values lower a stat
				playSound(mo.battlen, sfx_s3k8c)
				local dbuff = P_SpawnMobj(target.x, target.y, target.z+target.height, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_WHITE
				dbuff.scale = FRACUNIT*5/2

			elseif timer == 75
				return true
			end
		end,
}

attackDefs["phantom_pain"] = {
	name = "Phantom Pain",
	type = ATK_SUPPORT,
	accuracy = 40,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art.\nLowers attack to all enemies \nby 1 stage.",
	target = TGT_ALLENEMIES,
	debuff = true,
	anim = function(mo, targets, hittargets, timer)

		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT

		if timer == 25
			playSound(mo.battlen, sfx_eih4)
		end

		if timer >= 20 and timer <= 50
			for i = 1,3
				local thok = P_SpawnMobj(avgx + P_RandomRange(-80, 80)*FRACUNIT, avgy + P_RandomRange(-80, 80)*FRACUNIT, mo.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_MAGENTA
				if timer%2 then thok.color = SKINCOLOR_WHITE end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT*2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
				thok.momx = P_RandomRange(-6, 6)*FRACUNIT
				thok.momy = P_RandomRange(-6, 6)*FRACUNIT
			end
		elseif timer == 51
			for i = 1, 64
				local t = P_SpawnMobj(avgx, avgy, mo.z, MT_THOK)
				t.tics = TICRATE
				t.fuse = TICRATE
				t.frame = A
				t.momx = P_RandomRange(-32, 32)*FRACUNIT
				t.momy = P_RandomRange(-32, 32)*FRACUNIT
				t.momz = P_RandomRange(-32, 32)*FRACUNIT
				t.color = P_RandomRange(0, 1) and SKINCOLOR_MAGENTA or SKINCOLOR_WHITE
				t.scale = FRACUNIT*2
			end
		end

		if timer == 20
			playSound(mo.battlen, sfx_debuff)
			local orb = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
			orb.sprite = SPR_PHPN
			orb.frame = A|TR_TRANS30
			orb.scale = FRACUNIT*5
			orb.scalespeed = FRACUNIT/32
			orb.destscale = 1
			orb.tics = 2*TICRATE-15
			orb.color = SKINCOLOR_WHITE

		elseif timer == 51
			for i = 1,#hittargets -- damageObject must be used on all enemies individually.
				local target = hittargets[i]
				buffStat(target, "atk", -25)	-- negative values lower a stat
				local dbuff = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)
				dbuff.state = S_DBUFF1
				dbuff.color = SKINCOLOR_WHITE
				dbuff.scale = FRACUNIT*5/2
			end	
		end

		if timer == 60 + #targets*16
			return true
		end
	end,
}

attackDefs["dual_strike"] = {
		name = "Dual Strike",
		type = ATK_SLASH,
		power = 70,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		cost = 13,
		critical = 2,
		hits = 2,
		desc = "Light Slash Damage to a enemy\nhitting twice.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 15
			or timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
				playSound(mo.battlen, sfx_duastk)
				playSound(mo.battlen, sfx_duastk)

			elseif timer == 17
			or timer == 42
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_WHITE

			elseif timer == 16
			or timer == 41

				damageObject(target)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_WHITE
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_WHITE

			elseif timer == 65
				target.slashsprite = nil
				return true
			end
		end,
}

attackDefs["tdual_strike"] = {
		name = "True Dual Strike",
		type = ATK_SLASH,
		power = 110,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		cost = 13,
		critical = 2,
		hits = 2,
		desc = "Medium Slash Damage to a enemy\nhitting twice.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 15
			or timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_ICY
				s.scale = FRACUNIT*3/2
				playSound(mo.battlen, sfx_duastk)
				playSound(mo.battlen, sfx_duastk)

			elseif timer == 17
			or timer == 42
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_ICY

			elseif timer == 16
			or timer == 41

				damageObject(target)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_ICY
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_ICY

			elseif timer == 65
				target.slashsprite = nil
				return true
			end
		end,
}

attackDefs["sdual_strike"] = {
		name = "Supreme Dual Strike",
		type = ATK_SLASH,
		power = 300,
		accuracy = 91,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		status = COND_POISON,
		statuschance = 25,
		implicit = "jostimelesspummel",
		cost = 14,
		critical = 2,
		hits = 2,
		desc = "Heavy Slash Damage to a enemy\nhitting twice.May cause Poison",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				target.rolls = {}

			elseif timer == 15
			or timer == 40
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_AETHER
				s.scale = FRACUNIT*3/2
				s.rollangle = P_RandomRange(0, 359)*ANG1
				target.rolls[#target.rolls+1] = s.rollangle
				playSound(mo.battlen, sfx_duastk)
				playSound(mo.battlen, sfx_duastk)

			elseif timer == 17
			or timer == 42
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_AETHER

			elseif timer == 16
			or timer == 41

				damageObject(target)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				for i=1,10
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-35, 35)*FRACUNIT
					b.momy = P_RandomRange(-35, 35)*FRACUNIT
					b.momz = P_RandomRange(-35, 35)*FRACUNIT
					b.color = SKINCOLOR_AETHER
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT/2
					b.destscale = FRACUNIT/12
					b.tics = 35
				end

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_AETHER

			elseif timer == 65
				target.slashsprite = nil
				return true
			end
		end,
}

attackDefs["flicker"] = {
		name = "Flicker",
		type = ATK_SLASH,
		power = 200,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		cost = 12,
		critical = 2,
		technical = COND_FREEZE,
		desc = "Light Damage to all enemies \nwith quick slashes",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			for i = 1, #hittargets
				local time = timer - (i-1)*6
				local target = hittargets[i]

				if timer >= 10
				and timer <= 40
					if leveltime%5 == 0
						local avgx, avgy = 0, 0
						for i = 1, #targets
							avgx = $ + targets[i].x/FRACUNIT
							avgy = $ + targets[i].y/FRACUNIT
						end
						avgx = ($/#targets)	*FRACUNIT
						avgy = ($/#targets)	*FRACUNIT
					
						local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
						d.state = S_HOWL1
						d.color = SKINCOLOR_AETHER
						d.angle = mo.angle + ANG1*90
						d.scale = mo.scale*2
						d.scale = FRACUNIT*2
						d.destscale = FRACUNIT*7
						d.scalespeed = FRACUNIT/4
					end
				end
			
				if timer == 30
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3/2
				end		
			
				if timer == 31
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_WHITE
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end	
				end
			
				if time == 40
					local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_WHITE
					s.scale = FRACUNIT*3/2
					playSound(mo.battlen, sfx_duastk)
					playSound(mo.battlen, sfx_duastk)
			
				elseif time == 41
					damageObject(target)
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_WHITE
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end
				
					local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_WHITE
				end	
			
				if timer == 65 + (#hittargets-1)*6
					return true
				end
			end	
		end,
}

attackDefs["tflicker"] = {
		name = "True Flicker",
		type = ATK_SLASH,
		power = 260,
		accuracy = 93,
		costtype = CST_HPPERCENT,
		cost = 16,
		critical = 3,
		technical = COND_FREEZE,
		desc = "Medium Damage to all enemies \nwith quick slashes",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			for i = 1, #hittargets
				local time = timer - (i-1)*6
				local target = hittargets[i]

				if timer >= 10
				and timer <= 40
					if leveltime%5 == 0
						local avgx, avgy = 0, 0
						for i = 1, #targets
							avgx = $ + targets[i].x/FRACUNIT
							avgy = $ + targets[i].y/FRACUNIT
						end
						avgx = ($/#targets)	*FRACUNIT
						avgy = ($/#targets)	*FRACUNIT
					
						local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
						d.state = S_HOWL1
						d.color = SKINCOLOR_AETHER
						d.angle = mo.angle + ANG1*90
						d.scale = mo.scale*2
						d.scale = FRACUNIT*2
						d.destscale = FRACUNIT*7
						d.scalespeed = FRACUNIT/4
					end
				end
			
				if timer == 30
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_ICY
					s.scale = FRACUNIT*3/2
				end		
			
				if timer == 31
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_ICY
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end	
				end
			
				if time == 40
					local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_ICY
					s.scale = FRACUNIT*3/2
					playSound(mo.battlen, sfx_duastk)
					playSound(mo.battlen, sfx_duastk)
			
				elseif time == 41
					damageObject(target)
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_ICY
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end
				
					local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_ICY
				end	
			
				if timer == 65 + (#hittargets-1)*6
					return true
				end
			end	
		end,
}

attackDefs["sflicker"] = {
		name = "Supreme Flicker",
		type = ATK_SLASH,
		power = 350,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		cost = 19,
		critical = 3,
		technical = COND_FREEZE,
		desc = "Heavy Damage to all enemies \nwith quick slashes",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			for i = 1, #hittargets
				local time = timer - (i-1)*6
				local target = hittargets[i]

				if timer >= 10
				and timer <= 40
					if leveltime%5 == 0
						local avgx, avgy = 0, 0
						for i = 1, #targets
							avgx = $ + targets[i].x/FRACUNIT
							avgy = $ + targets[i].y/FRACUNIT
						end
						avgx = ($/#targets)	*FRACUNIT
						avgy = ($/#targets)	*FRACUNIT
					
						local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
						d.state = S_HOWL1
						d.color = SKINCOLOR_AETHER
						d.angle = mo.angle + ANG1*90
						d.scale = mo.scale*2
						d.scale = FRACUNIT*2
						d.destscale = FRACUNIT*7
						d.scalespeed = FRACUNIT/4
					end
				end
			
				if timer == 30
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_AETHER
					s.scale = FRACUNIT*3/2
				end		
			
				if timer == 31
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_AETHER
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end	
				end
			
				if time == 40
					local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_AETHER
					s.scale = FRACUNIT*3/2
					playSound(mo.battlen, sfx_duastk)
					playSound(mo.battlen, sfx_duastk)
			
				elseif time == 41
					damageObject(target)
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_AETHER
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end
				
					local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_AETHER
				end	
			
				if timer == 65 + (#hittargets-1)*6
					return true
				end
			end	
		end,
}

attackDefs["chrono_down"] = {
	name = "Chrono Down",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 12,
	desc = "Orbal Art.\nLowers agility to all enemies \nby 1 stage",
	target = TGT_ALLENEMIES,
	debuff = true,
	anim = function(mo, targets, hittargets, timer)
		
		local avgx, avgy = 0, 0
		for i = 1, #hittargets -- Get average position of targets
			avgx = $ + hittargets[i].x/FRACUNIT
			avgy = $ + hittargets[i].y/FRACUNIT
		end
		avgx = ($/#hittargets)*FRACUNIT
		avgy = ($/#hittargets)*FRACUNIT
		
		
		if timer == 1
			playSound(mo.battlen, sfx_chrdwn)
			playSound(mo.battlen, sfx_chrdwn)
		end
		
		if timer == 106
			playSound(mo.battlen, sfx_debuff)
		end	
		
		if timer == 20
			local m = P_SpawnMobj(avgx, avgy, mo.z, MT_DUMMY)			
			m.state = S_CHRONODRIVE1
			m.scale = FRACUNIT*3
			m.renderflags = $|RF_FLOORSPRITE|RF_SPLATMASK
			m.color = SKINCOLOR_PURPLE
		end	
		if timer >= 20 and timer < 75
			for i = 1,#hittargets
				local t = hittargets[i]
				summonAura(t, SKINCOLOR_DUSK)
			end	
		end
		
		if timer >= 50 and timer <= 100
			for i = 1,#hittargets
				local e = hittargets[i]
				for i = 1, 8
					local spread = (timer-30)
					local x = P_RandomRange(-spread, spread)*FRACUNIT +e.x
					local y = P_RandomRange(-spread, spread)*FRACUNIT +e.y
					local z = P_RandomRange(-spread, spread)*FRACUNIT +e.z + e.height/2

					local t = P_SpawnMobj(x, y, z, MT_THOK)
					t.fuse = t.tics
					t.color = P_RandomRange(0, 1) and SKINCOLOR_BLACK or SKINCOLOR_PURPLE
					t.frame = A
					t.scale = FRACUNIT/4 + (spread*FRACUNIT/32)
					t.momz = -FRACUNIT/12
				end
			end
		end	

		if timer == 105
			for i = 1,#hittargets
				local e = hittargets[i]
				for i = 1, 64
					local t = P_SpawnMobj(e.x, e.y, e.z, MT_THOK)
					t.tics = TICRATE
					t.fuse = TICRATE
					t.frame = A
					t.momx = P_RandomRange(-32, 32)*FRACUNIT
					t.momy = P_RandomRange(-32, 32)*FRACUNIT
					t.momz = P_RandomRange(-32, 32)*FRACUNIT
					t.color = P_RandomRange(0, 1) and SKINCOLOR_BLACK or SKINCOLOR_PURPLE
					t.scale = FRACUNIT*3/2
				end	
			end
		end	
				
			
		if timer == 106
			for i = 1,#hittargets
				local target = hittargets[i]
				buffStat(target, "agi", -25)
			end
		elseif timer == 120 + #targets*16
			return true
		end
	end,
}

attackDefs["fangflicker"] = {
		name = "Fang Flicker",
		type = ATK_SLASH,
		power = 620,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		cost = 18,
		critical = 3,
		technical = COND_FREEZE,
		desc = "Severe Damage to all enemies \nwith quick slashes",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			
			if timer == 10
				playSound(mo.battlen, sfx_flickr)
			end	
			
			for i = 1, #hittargets
				local time = timer - (i-1)*6
				local target = hittargets[i]

				if timer >= 10
				and timer <= 40
					if leveltime%5 == 0
						local avgx, avgy = 0, 0
						for i = 1, #targets
							avgx = $ + targets[i].x/FRACUNIT
							avgy = $ + targets[i].y/FRACUNIT
						end
						avgx = ($/#targets)	*FRACUNIT
						avgy = ($/#targets)	*FRACUNIT
					
						local d = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*64, MT_THOK)
						d.state = S_HOWL1
						d.color = SKINCOLOR_AETHER
						d.angle = mo.angle + ANG1*90
						d.scale = mo.scale*2
						d.scale = FRACUNIT*2
						d.destscale = FRACUNIT*7
						d.scalespeed = FRACUNIT/4
					end
				end
			
				if timer == 30
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_BONE
					s.scale = FRACUNIT*3/2
				end		
			
				if timer == 31
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_BONE
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end	
				end
			
				if time == 40
					local s = P_SpawnMobj(target.x, target.y, target.z + 1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_BONE
					s.scale = FRACUNIT*3/2
					playSound(mo.battlen, sfx_duastk)
					playSound(mo.battlen, sfx_duastk)
			
				elseif time == 41
					damageObject(target)
					for i=1,10
						local b = P_SpawnMobj(target.x, target.y, target.z + 20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-35, 35)*FRACUNIT
						b.momy = P_RandomRange(-35, 35)*FRACUNIT
						b.momz = P_RandomRange(-35, 35)*FRACUNIT
						b.color = SKINCOLOR_BONE
						b.frame = A|FF_FULLBRIGHT
						b.scale = FRACUNIT/2
						b.destscale = FRACUNIT/12
						b.tics = 35
					end
				
					local s = P_SpawnMobj(target.x, target.y, target.z + 40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_BONE
				end	
			
				if timer == 65 + (#hittargets-1)*6
					return true
				end
			end	
		end,
}

attackDefs["abyss_fall"] = {
		name = "Abyss Fall",
		type = ATK_CURSE,
		power = 720,
		accuracy = 95,
		costtype = CST_SP,
		cost = 48,
		desc = "Orbal Art\nSevere curse damage to a enemy.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
			or timer == 20
				playSound(mo.battlen, sfx_eih4)
			end
			if timer <= 70
				for i = 1,24
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z + P_RandomRange(30, 60)<<FRACBITS, MT_DUMMY)
					thok.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
					thok.colorized = true
					thok.color = SKINCOLOR_MAGENTA
					if timer%2 then thok.color = SKINCOLOR_BLACK end
					thok.angle = P_RandomRange(1,360)*ANG1
					local rt = P_RandomRange(-20, 20)*FRACUNIT
					local ra = P_RandomRange(5, 15)*FRACUNIT
					P_InstaThrust(thok,thok.angle,rt)
					thok.momz = ra
					thok.tics = 50
					thok.scale = 1
					thok.rollangle = P_RandomRange(45,135)*ANG1
					thok.sprite = SPR_THOK
					thok.scalespeed = ((FRACUNIT/20)*timer)/35
					thok.destscale = (FRACUNIT/20)*timer
				end
			end
			
			if timer == 70
				playSound(mo.battlen, sfx_eih3)
			end
			
			if timer > 95 and timer < 115
				local rcol = {SKINCOLOR_PURPLE,SKINCOLOR_NEON,SKINCOLOR_VIOLET,SKINCOLOR_BLACK,SKINCOLOR_MAGENTA}
					
					for i = 1,20
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
						thok.color = rcol[P_RandomRange(1,#rcol)]
						thok.frame = A|FF_FULLBRIGHT
						thok.flags = $|MF_GRENADEBOUNCE|MF_MISSILE|MF_NOCLIPTHING & !MF_NOGRAVITY
						thok.tics = 175
						thok.scale = mo.scale/2
						thok.destscale = 1
						thok.scalespeed = (mo.scale/2)/175
						thok.momx = P_RandomRange(-15,15)*FRACUNIT
						thok.momy = P_RandomRange(-15,15)*FRACUNIT
						thok.momz = P_RandomRange(5,15)*FRACUNIT
					end
				
				if leveltime%2 == 0
					local t = P_SpawnMobj(target.x, target.y, target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = C|TR_TRANS10
					t.color = leveltime%8 == 0 and SKINCOLOR_WHITE or SKINCOLOR_BLACK
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/6
				end

				if leveltime%3 == 0
					local caman = R_PointToAngle(target.x, target.y)

					local t = P_SpawnMobj(target.x + 2*cos(caman), target.y + 2*cos(caman), target.z, MT_THOK)
					t.fuse = TICRATE/2
					t.sprite = SPR_MUDO
					t.tics = -1
					t.frame = D|TR_TRANS10
					t.color = SKINCOLOR_PURPLE
					t.scale = FRACUNIT/3
					t.destscale = FRACUNIT*3
					t.scalespeed = FRACUNIT/4
				end
			end
			
			if timer == 97
				damageObject(target)
			end
			if timer >= 1 and timer <= 100
				-- hehe stolen

				for i = 1, 16

					local spread = ((timer/2)-90)
					local x = P_RandomRange(-spread, spread)*FRACUNIT +target.x
					local y = P_RandomRange(-spread, spread)*FRACUNIT +target.y
					local z = P_RandomRange(-spread, spread)*FRACUNIT +target.z + target.height/2

					local t = P_SpawnMobj(x, y, z, MT_THOK)
					t.fuse = t.tics
					t.color = P_RandomRange(0, 1) and SKINCOLOR_BLACK or SKINCOLOR_MAGENTA
					t.frame = A
					t.scale = FRACUNIT/4 + (spread*FRACUNIT/32)
					t.momz = -FRACUNIT/12
				end
			end
			if timer == 140
				return true
			end
		end,
	}