if not srb2p return end

DNG_Abilities["lloyd"] = {

    jfunc =     function(p)
                    local mo = p.mo

                    p.drawangle = mo.angle
                    mo.momz = 0
                    local t = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
                    t.color = mo.color
                    P_InstaThrust(mo,mo.angle,(50*FRACUNIT))
                    S_StartSound(p.mo,sfx_spdpad)
					mo.state = S_PLAY_FLOAT
                end,

        func =        function(p)
                    local mo = p.mo

                    if mo.p_abl
                        if not P_IsObjectOnGround(mo)
                            if (leveltime%3)
                                local g = P_SpawnGhostMobj(mo)
                                g.tics = 4
                                g.colorized = true
                            end
                        else
                            mo.p_abl = false
                        end
                    end
                end,
}

freeslot("SPR_BATT", "SPR_LCHR", "SPR_LFIR", "SPR_DEFD", "SPR_LRIP", "SPR_LHOP", "SPR_LTGR", "SPR_TIGR", 
"sfx_lydhit", "sfx_lydchr", "sfx_courge", "sfx_lsheal", "sfx_rissun", "sfx_cutlyd", "sfx_scraft", 
"sfx_lroar", "sfx_ltchr", "sfx_bascp", "sfx_lorinf", "sfx_firbol", "sfx_rinwdj", "sfx_burhea")



sfxinfo[sfx_rissun].caption = "Rising Sun!" //Caption says this
sfxinfo[sfx_rissun].priority = "99999" //Make it high so NOTHING can interrupt this one

charStats["lloyd"] = {

		-- GENERAL

		name = "Lloyd",			-- This is only for bots / enemies
		basehp = 65,			-- base HP for level 1
		basesp = 50,
		persona = "lloydskillset",
		melee_natk = "brave_smash",	-- normal melee attack
		melee_satk = "risingsun", //Let's gooooooooooooo
		
		supercolor_start = SKINCOLOR_SUPERLLOYD1,
		
		wep = "striker",		-- default weapon.
		weptype = WPT_GENERICMELEE,	-- Equippable weapon type(s)

		atk = 45,
		acc = 90,
		crit = 5,

		-- ANIMS
		-- Anims are built like this:
		-- {SPR_SPRITE, frame1, frame2, frame3, ... , duration between each frame}

		anim_stand = 		{SPR_BATT, A, 8, "SPR2_BATT"},					-- standing
		anim_stand_hurt =	{SPR_BATT, A, 1, "SPR2_BATT"},					-- standing (low HP) *
		anim_stand_bored =	{SPR_BATT, A, 8, "SPR2_BATT"},					-- standing (occasionally plays after anim_stand has played several times)
		anim_guard = 		{SPR_DEFD, A, 1, "SPR2_DEFD"},					-- guarding
		anim_move =			{SPR_PLAY, A, B, C, D, 2, "SPR2_WALK"},	-- moving
		anim_run =			{SPR_PLAY, A, B, C, D, E, 2, "SPR2_RUN_"},	-- guess what
		anim_atk =			{SPR_PLAY, A, B, C, 2, "SPR2_ROLL"},			-- attacking
		anim_aoa_end =		{SPR_PLAY, A, 2, "SPR2_FALL"},			-- jumping out of all-out attack
		anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- taking damage
		anim_getdown =		{SPR_PLAY, A, 35, "SPR2_PAIN"},					-- knocked down from weakness / crit *
		anim_downloop =		{SPR_LRIP, A, 1, "SPR2_LRIP"},					-- is down
		anim_getup =		{SPR_BATT, A, 1, "SPR2_BATT"},			-- gets up from down
		anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},					-- dies
		anim_revive =		{SPR_PLAY, A, B, C, 1, "SPR2_ROLL"},			-- gets revived
		anim_evoker =		{SPR_LCHR, A, 8, "SPR2_LCHR"},
		anim_evoker_shoot = {SPR_LFIR, A, 8, "SPR2_LFIR"},
		anim_special1 =		{SPR_BATT, A, 1, "SPR2_BATT"},	-- charge
		anim_special2 =		{SPR_LHOP, A, 2, "SPR2_LHOP"},	-- dash
		anim_special3 =		{SPR_PLAY, A, 35, "SPR2_TRNS"}, // Rising
		anim_special4 =		{SPR_PLAY, G, 35, "SPR2_TRNS"}, // SUUUUUN
		anim_special5 =		{SPR_LTGR, A, 35, "SPR2_LTGR"},
		anim_special6 =		{SPR_BATT, B, 35, "SPR2_BATT"}, //Burning Heart
		anim_special7 =		{SPR_BATT, C, 35, "SPR2_BATT"},
		
		vfx_summon = {"sfx_llsmn1", "sfx_llsmn2", "sfx_llsmn3", "sfx_llsmn4", "sfx_llsmn5"},
		vfx_skill = {"sfx_llskl1", "sfx_llskl2", "sfx_llskl3", "sfx_llskl4"},
		vfx_item = {"sfx_llitem"},
		vfx_hurt = {"sfx_llhrt1", "sfx_llhrt2", "sfx_llhrt3"},
		vfx_hurtx = {"sfx_llxhr", "sfx_llxhr2"},
		vfx_die = {"sfx_lldie", "sfx_lldie2"},
		vfx_heal = {"sfx_llheal", "sfx_llhel2", "sfx_llhels"},
		vfx_healself = {"sfx_llhels"},
		vfx_kill = {"sfx_llkil1", "sfx_llkil2", "sfx_llkil3"},
		vfx_1more = {"sfx_ll1mor", "sfx_ll1mo"},
		vfx_crit = {"sfx_llcrt1", "sfx_llcrt2", "sfx_llcrt3", "sfx_llcrt4"},
		vfx_aoaask = {"sfx_llaoi1", "sfx_llaoi2", "sfx_llaoi3"},
		vfx_aoado = {"sfx_llaoa1", "sfx_llaoa2", "sfx_llaoa3", "sfx_llaoa4"},
		vfx_aoarelent = {"sfx_llaor1"},
		vfx_miss = {"sfx_llmis1", "sfx_llmis2", "sfx_llmis3"},
		vfx_dodge = {"sfx_lldog1", "sfx_lldog2", "sfx_lldog3"},
		vfx_win = {"sfx_llwin1", "sfx_llwin2", "sfx_llwin3", "sfx_llwin4"},
		vfx_levelup = {"sfx_llkil2", "sfx_lllevl", "sfx_lllev2"},
		vfx_tartarus_pit = {"sfx_llxhr2"},
		vfx_tartarus_item = {"sfx_lyitem"},
		vfx_tartarus_spring = {"sfx_lyspng"},
		vfx_tartarus_spike = {"sfx_llhrt1", "sfx_llhrt2", "sfx_llhrt3"},
		vfx_tartarus_critspike = {"sfx_llxhr"},
		vfx_tartarus_spikepit = {"sfx_lympit"},

		icon = "H_LYDICO",	-- icon for net select and other menus
		hudbust = "H_LYDBAR",			-- patch to draw on the stat hud
		hudaoa = "H_LYDAOA",	-- patch for all out attack hud
		hudcutin = "LLYD_A",	-- cut in
		aoa_quote = "Let's overcome this \nbarrier together!",

		tip = "The Leader of the Special Support Section. A physical user with Fire(Earth in Bionis) and Attack Buffs. His high critical rate can make easily knock down enemies but beware to not waste his HP or he will be in trouble."
}
	
VFX_freeslotC("lloyd")
	
personaList["lloydskillset"] = {
		-- GENERAL
		name = "Lloyd",
		arcana = nil,

		-- STATS (@ lv10)

		sprite = SPR_NULL,
		anim_idle = 	{SPR_NULL, A, 8},
		anim_atk  = 	{SPR_NULL, A, 8},
		startframe = 0,

		strength = 10,
		magic = 6,
		endurance = 7,
		luck = 10,
		agility = 7,
		weak = ATK_CURSE,
		resist = ATK_FIRE|ATK_NUCLEAR,
		skills = {
					{bionis and "stone_spike" or "firebolt", 1}, {"lunge", 3}, 
					{"tear", 7},
					{"axle_rush", 10}, {bionis and "quake" or "heatwave", 13},
					{"encourage", 16}, {"sonic punch", 17, "lunge"}, 
					{bionis and "stone_hammer" or "magma_blaze", 20, bionis and "stone_spike" or "firebolt"},
					{"assault dive", 23, "sonic punch"},
					{"teara", 25, "tear"}, {"raging_spin", 27, "axle_rush"},
					{"hard knuckle", 29},
					{bionis and "stone_impact" or "flare_butterfly", 31, bionis and "quake" or "heatwave"},
					{"extend_hearts", 33, "encourage"},
					{"burning_heart", 37},
					{"stun_break", 41, "assault dive"},
					{"tearal", 45, "teara"},
					{"zero_breaker", 47, "raging_spin"},
					{bionis and "earth_lance" or "volcanic_rave", 50, bionis and "stone_hammer" or "magma_blaze"},
					{"iron fist", 55, "hard knuckle"},
					{bionis and "grand_press" or "lord_inferno", 59, bionis and "stone_impact" or "flare_butterfly"},
					{"tigercharge", 66, "stun_break"}, //Zoraxua note - added this
					{bionis and "titanic_roar" or "crimson_ray", 75, bionis and "earth_lance" or "volcanic_rave"},
				},
}


attackDefs["risingsun"] = {
		name = "Rising Sun",
		type = ATK_ALMIGHTY,
		power = 320, //Gonna try to land thrice so lets not make this tooooo high
		accuracy = 999,
		costtype = CST_HP,
		technical = COND_BURN, //Free crits on burning enemies lol
		status = COND_BURN, //And lets make burn likely
		statuschance = 25,
		cost = 300,
		nometronome = true,
		norandom = true,
		critical = 25,
		hits = 3, //Mmh tasty bonus damage lol
		anim_norepel = true,
		norepel = true, //Please no reflect lol
		//Yes physical is not set to true, so the Cut in can play :3
		desc = "Lloyd's S-Craft\nDestroys enemies with tons\nof smacking and fire", //Put one here ya want :p
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
		
		local cam = server.P_BattleStatus[mo.battlen].cam
			
		
		for i = 1, #hittargets
			local target = hittargets[i]
				if timer == 1 //LAUNCH (BASE ZONE)
					for i = 1, 8 //Garu stuffs to simulate da wind
						local g = P_SpawnMobj(target.x, target.y, target.z + P_RandomRange(0, 60)*FRACUNIT, MT_GARU)
						g.target = target
						g.angle = FixedAngle(P_RandomRange(1, 360)*FRACUNIT)
						if i == 1 or i == 8
							g.jizzcolor = true
						end
						if i%2
							g.invertrotation = true
						end
						g.dist = P_RandomRange(45, 90)
						g.tics = 24
					end
				elseif timer == 5
					playSound(mo.battlen, sfx_rinwdj)
				elseif timer == 20 //ZOOM
					P_SetObjectMomZ(target, 60*FRACUNIT)
				elseif timer == 25 //ZOOM 2
					P_SetObjectMomZ(mo, 70*FRACUNIT) //Bye Lloyd lol
				elseif timer > 35
				and timer < 315
				mo.momz = 0
				target.momz = 0
				end //Momz lol, that's sorted now
			end
			
			if timer == 35 //Oi camera, move
					local cx = mo.x + 21*cos(mo.angle + ANG1*20)
					local cy = mo.y + 21*sin(mo.angle + ANG1*20)
						if #hittargets < 3
							P_TeleportMove(cam, cx, cy, hittargets[1].z + FRACUNIT*16)
							server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[1].x, hittargets[1].y) 
						elseif #hittargets > 4
							P_TeleportMove(cam, cx, cy, hittargets[3].z + FRACUNIT*16)
							server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[3].x, hittargets[3].y) 
						else
							P_TeleportMove(cam, cx, cy, hittargets[2].z + FRACUNIT*16)
							server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[2].x, hittargets[2].y) 
						end
	
			elseif timer >= 40 //so 40..
			and timer <= 110 //To 110.. 2 seconds
			local rnd = P_RandomRange(1,#hittargets) //Spicy RNG to randomly "hit" targets
			local rtarget = hittargets[rnd]
//				if timer == 40
//					rtarget.rolls = {}
//				end
				local s = P_SpawnMobj(rtarget.x, rtarget.y, rtarget.z, MT_DUMMY)
				s.state = S_SLASHING_2_1
				s.color = SKINCOLOR_ORANGE //Slicy stuffs
				s.scale = FRACUNIT*3
				s.rollangle = P_RandomRange(0, 359)*ANG1
//				rtarget.rolls[#rtarget.rolls+1] = s.rollangle
				if not (leveltime%6)
				playSound(mo.battlen, sfx_lydhit)
				createSplat(mo)
				end
			elseif timer == 125 //CAMERA!!! Please turn!
				local cx = mo.x + 128*cos(mo.angle + ANG1*25)
				local cy = mo.y + 128*sin(mo.angle + ANG1*25)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				ANIM_set(mo, mo.anim_special3, true)
			elseif timer == 135 
			elseif timer == 145 //KA
				DoExplosion(mo)//BEWWWWWWWM
			elseif timer == 160
			playSound(mo.battlen, sfx_cutlyd)
			playSound(mo.battlen, sfx_rissun)
			ANIM_set(mo, mo.anim_special4, true)
			elseif timer == 190
			ANIM_set(mo, mo.anim_special3, true)
			elseif timer >= 195
			and timer < 230
				for i = 1, 24
					local boom = P_SpawnMobj(mo.x + P_RandomRange(-48, 48)*FRACUNIT, mo.y + P_RandomRange(-48, 48)*FRACUNIT, mo.z - 32*FRACUNIT, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				if timer%4 == 0
					playSound(mo.battlen, sfx_fire1)
				end
			localquake(mo.battlen, FRACUNIT*64, 10)
			ANIM_set(mo, mo.anim_special4, true)
			elseif timer == 230
				local cx = mo.x + 21*cos(mo.angle + ANG1*20)
				local cy = mo.y + 21*sin(mo.angle + ANG1*20)
						if #hittargets < 3
							P_TeleportMove(cam, cx, cy, hittargets[1].z + FRACUNIT*32)
							server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[1].x, hittargets[1].y) 
						elseif #hittargets > 4
							P_TeleportMove(cam, cx, cy, hittargets[3].z + FRACUNIT*32)
							server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[3].x, hittargets[3].y) 
						else
							P_TeleportMove(cam, cx, cy, hittargets[2].z + FRACUNIT*32)
							server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, hittargets[2].x, hittargets[2].y) 
						end //Turn back
			elseif timer > 230
			and timer <= 300
				if timer%4 == 0
					playSound(mo.battlen, sfx_fire1)
				end
				for i = 1, #hittargets
					local target = hittargets[i]
					for i = 1, 6 //Let's not kill the sprite limit lol 
						local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z - 32*FRACUNIT, MT_DUMMY)
						boom.state = S_QUICKBOOM1
						boom.momz = P_RandomRange(0, 48)*FRACUNIT
						boom.scale = FRACUNIT*2
					end
					if timer == 250
					or timer == 270
						damageObject(target)
					end
					
					if timer == 295
						damageObject(target)
						DoExplosion(target)
					end
				end
			elseif timer >= 315 //Camera cools
			and timer < 360
				ANIM_set(mo, mo.anim_aoa_end, true)
				local cx = mo.x - 168*cos(mo.angle + ANG1*20)
				local cy = mo.y - 168*sin(mo.angle + ANG1*20)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, mo.x, mo.y))
			end
			if timer == 360
				return true
			end
		end,
}


attackDefs["magma_blaze"] = {
		name = "Magma Blaze",
		type = ATK_FIRE,
		power = 140,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 5,
		cost = 8,
		desc = "Orbal Art.\nMedium fire damage to a enemy\nMay burn.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 25
				playSound(mo.battlen, sfx_s3k6f)
			end

			if timer >= 20 and timer <= 50
				for i = 1,3
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_RED
					if timer%2 then thok.color = SKINCOLOR_KETCHUP end
					thok.frame = A
					thok.tics = 35
					thok.scale = FRACUNIT/2
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(5, 10)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end
			elseif timer >= 51 and timer <= 60
				if timer == 52
					damageObject(target)
					DoExplosion(target)
					for i = 1,16
						local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						if i%2 then thok.color = SKINCOLOR_RED else thok.color = SKINCOLOR_KETCHUP end
						thok.frame = A
						thok.destscale = 1
						thok.tics = 30
						thok.scalespeed = FRACUNIT/6
						thok.angle = ANGLE_22h*(i-1)
						P_InstaThrust(thok, thok.angle, 69*FRACUNIT)
					end
				end
				for i = 1,8
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.color = SKINCOLOR_RED
					if timer%2 then thok.color = SKINCOLOR_KETCHUP end
					if i == 1
						thok.color = SKINCOLOR_CRIMSON
					end
					thok.frame = A
					thok.tics = 35
					thok.scalespeed = FRACUNIT/32
					thok.destscale = 1
					thok.momz = P_RandomRange(15, 30)*FRACUNIT
					thok.momx = P_RandomRange(-6, 6)*FRACUNIT
					thok.momy = P_RandomRange(-6, 6)*FRACUNIT
				end

			elseif timer == 90
				return true
			end
		end,
	}

attackDefs["tigercharge"] = { //Zoraxua be tired but im fukin bALLIN' 
		name = "Tiger Charge", 
		type = ATK_STRIKE,
		power = 680, 
		accuracy = 100,
		status = COND_SHOCK,
		implicit = "lystarblast",
		statuschance = 5,
		costtype = CST_HPPERCENT, //Helf
		cost = 20, //Thats 1 in 4 (wow!)
		critical = 5, //Thats 1 in 3 almost (!wow!)
		desc = "Charges like a tiger to a enemy\ncausing Severe Damage\nMay Shock",
		target = TGT_ENEMY,
		norepel = true,
		anim_norepel = true,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer < 36
			
				if timer == 1
                    if mo.skin == "lloyd"
                        ANIM_set(mo, mo.anim_special5)
                    end
					playSound(mo.battlen, sfx_ltchr)
					local cx = mo.x - 168*cos(mo.angle + ANG1*20)
					local cy = mo.y - 168*sin(mo.angle + ANG1*20)
					CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, mo.z + FRACUNIT*7, 70*FRACUNIT)
					CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
				end
				local h_angle = P_RandomRange(1, 359)*ANG1
				local v_angle = P_RandomRange(1, 359)*ANG1
				local dist = 256
				local spd = P_RandomRange(40, 50)

				local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
				local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
				local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_CYAN
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_CYAN
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
				local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

				s.frame = A
				s.color = SKINCOLOR_CYAN
				s.scale = FRACUNIT*2
				s.destscale = FRACUNIT/5
				s.target = target
				s.tics = 10
				s.momx = (mo.x - s.x)/10
				s.momy = (mo.y - s.y)/10
				s.momz = (mo.z - s.z)/10
				
			elseif timer < 71
				
				if timer == 36
					playSound(mo.battlen, sfx_lroar)
					
				local cam = server.P_BattleStatus[mo.battlen].cam

				local x = cam.x - 380*cos(cam.angle)
				local y = cam.y - 380*sin(cam.angle)
				CAM_goto(cam, x, y, cam.z + FRACUNIT*24)
				end
				P_StartQuake(FRACUNIT*50, 10)
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				s.state = S_THOK
				s.tics = -1
				s.fuse = 10
				s.scale = 5*FRACUNIT
				s.color = SKINCOLOR_CYAN
				P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				s.state = S_THOK
				s.tics = -1
				s.fuse = 10
				s.scale = 5*FRACUNIT
				s.color = SKINCOLOR_CYAN
				P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
				local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
				s.state = S_THOK
				s.tics = -1
				s.fuse = 10
				s.scale = 5*FRACUNIT
				s.color = SKINCOLOR_CYAN
				P_InstaThrust(s,(R_PointToAngle2(mo.x, mo.y, target.x, target.y)),100*FRACUNIT)
				
				
				if timer == 38
					damageObject(target)
					playSound(mo.battlen, sfx_lydhit)
					for k,v in ipairs(mo.allies)
						if v and v.control and v.control.valid
							P_FlashPal(v.control, 5, 10)
                            if mo.skin == "lloyd"
                                ANIM_set(mo, mo.anim_special2)
                            end
						end
					end
				end
				if timer == 52
                    if mo.skin == "lloyd"
                        ANIM_set(mo, mo.anim_special5)
                    end
				end
			end
			if timer == 80
				return true
			end
		end,
}

attackDefs["tear"] = {
		name = "Tear",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 5,
		power = 50,
		desc = "Orbal Art.\nSmall HP recovery to 1 ally\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLY,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_tear)
					end
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					local heals = P_RandomRange(50, 60)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -heals)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["teara"] = {
		name = "Teara",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 12,
		power = 150,
		desc = "Orbal Art.\nMedium HP recovery to 1 ally\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLY,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_teara)
					end
					if time < 50
						for i = 1, 2
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
							end
						end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					local heals = P_RandomRange(150, 160)
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -heals)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["tearal"] = {
		name = "Tearal",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 16,
		power = 999,
		desc = "Orbal Art.\nLarge HP recovery to 1 ally\nAlso Cures Burn",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.hp >= target.maxhp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,

		target = TGT_ALLY,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_tearal)
					end
					if time < 50
						for i = 1, 5
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/2
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
						end
					end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_CYAN
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					local heals = target.maxhp
					playSound(mo.battlen, sfx_lsheal)
					damageObject(target, -heals)
					if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
					end
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["zero_breaker"] = {
		name = "Zero Breaker",
		type = ATK_STRIKE,
		power = 460,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		cost = 14,
		critical = 3,
		desc = "Heavy Damage to all enemies with \npowerful shockwaves",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #hittargets
				local color = SKINCOLOR_KETCHUP
				local target = hittargets[i]
				local time = timer - (i-1)*6

				local atk = P_SpawnMobj(target.x + P_RandomRange(-90, 90)*FRACUNIT, target.y + P_RandomRange(-90, 90)*FRACUNIT, target.z + P_RandomRange(0, 90)*FRACUNIT, MT_DUMMY)
				atk.state = S_CDUST1
				atk.color = SKINCOLOR_CRIMSON
				atk.momz = FRACUNIT*8
				atk.destscale = FRACUNIT*10
				atk.tics = 10

				if time == 1
					target.rolls = {}

				elseif time == 15
				or time == 20
				or time == 25	-- lazy
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = color
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_lydhit)
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle

				elseif time == 17
				or time == 22
				or time == 27

					if time == 22
					and not (i%2)

						local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
						d.sprite = SPR_THMP
						d.frame = C|FF_FULLBRIGHT
						d.scale = FRACUNIT/4
						d.destscale = FRACUNIT*3
						d.scalespeed = FRACUNIT/8
						d.fuse = TICRATE-10
						d.tics = d.fuse
						d.momz = FRACUNIT*2
						d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.color = color
					end


				elseif time == 19
				or time == 24
				or time == 29

					if time == 24
						damageObject(target)
						playSound(mo.battlen, sfx_bexpld)
						if not target.plyr
							createSplat(mo)
							createSplat(mo)
						end
						localquake(mo.battlen, FRACUNIT*10, 10)
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = color

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = color
					s.rollangle = target.rolls[#target.rolls]
				end
			end
			if timer == 55 + (#hittargets-1)*6
				return true
			end
		end,
}


attackDefs["raging_spin"] = {
		name = "Raging Spin",
		type = ATK_STRIKE,
		power = 200,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		cost = 9,
		critical = 5,
		desc = "Medium Damage to all enemies with \nstrong shockwaves",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #hittargets
				local color = SKINCOLOR_ORANGE
				local target = hittargets[i]
				local time = timer - (i-1)*6

				if time == 1
					target.rolls = {}

				elseif time == 15
				or time == 20
				or time == 25	-- lazy
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = color
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_lydhit)
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle

				elseif time == 17
				or time == 22
				or time == 27

					if time == 22
					and not (i%2)

						local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
						d.sprite = SPR_THMP
						d.frame = C|FF_FULLBRIGHT
						d.scale = FRACUNIT/4
						d.destscale = FRACUNIT*3
						d.scalespeed = FRACUNIT/8
						d.fuse = TICRATE-10
						d.tics = d.fuse
						d.momz = FRACUNIT*2
						d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.color = color
					end

				elseif time == 19
				or time == 24
				or time == 29

					if time == 24
						damageObject(target)
						playSound(mo.battlen, sfx_bexpld)
						if not target.plyr
							createSplat(mo)
							createSplat(mo)
						end
						localquake(mo.battlen, FRACUNIT*10, 10)
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = color

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = color
					s.rollangle = target.rolls[#target.rolls]
				end
			end

			if timer == 55 + (#hittargets-1)*6
				return true
			end
		end,
}

attackDefs["firebolt"] = {
		name = "Fire Bolt",
		type = ATK_FIRE,
		power = 60,
		accuracy = 95,
		costtype = CST_SP,
		cost = 4,
		status = COND_BURN,
		statuschance = 5,
		desc = "Orbal Art.\nLight fire damage to a enemy.\nMay burn",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 15
                local boom = P_SpawnMobj(mo.x,mo.y,mo.z+(FRACUNIT*32), MT_DUMMY)
                boom.scale = FRACUNIT*2
                boom.state = S_TRAILS_FIREBOLT1
				boom.fuse = 15
				boom.momx = (target.x - boom.x)/15
				boom.momy = (target.y - boom.y)/15
				boom.momz = (target.z - boom.z)/15
				target.bruhn = boom 
            elseif timer == 30
                local boom = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_BOSSEXPLODE)
                boom.scale = FRACUNIT*4
                boom.state = S_PFIRE1
                damageObject(target)


                for i = 1, 8
					local smoke = P_SpawnMobj(boom.x, boom.y, boom.z, MT_SMOKE)
					smoke.scale = FRACUNIT*1
					smoke.momx = P_RandomRange(-5, 5)*FRACUNIT
					smoke.momy = P_RandomRange(-5, 5)*FRACUNIT
					smoke.momz = P_RandomRange(3, 6)*FRACUNIT
                end

                local sm = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
                sm.fuse = TICRATE/2
                sm.scale = target.scale*3/2

                elseif timer == 70
                    return true
                end
				
            if timer == 10
            or timer == 14
                playSound(mo.battlen, sfx_firbol)
            elseif timer == 30
                playSound(mo.battlen, sfx_fire2)
                localquake(mo.battlen, FRACUNIT*32, 8)
            end
			
			if target.bruhn and target.bruhn.valid
				local srbtwomoment = P_SpawnGhostMobj(target.bruhn)
				srbtwomoment.colorized = true
				srbtwomoment.color = SKINCOLOR_RED
			end
        end,	
}

attackDefs["heatwave"] = {
		name = "Heatwave",
		type = ATK_FIRE,
		power = 60,
		accuracy = 90,
		costtype = CST_SP,
		cost = 8,
		status = COND_BURN,
		statuschance = 2,
		desc = "Orbal Art.\nLight fire damage to all enemies.\nMay burn",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			for tg = 1,#hittargets
				local t = hittargets[tg]
				local time = timer + ((tg - 1) * 5)
				if time == 1
					playSound(mo.battlen, sfx_s3kc2s)
				elseif time == 30
					playSound(mo.battlen, sfx_s3k43)
				elseif time == 50
					playSound(mo.battlen, sfx_s3k3e)
				end
				if time > 0
					if time < 30
						local fume = P_SpawnMobj(t.x,t.y,t.z,MT_DUMMY)
						fume.state = S_CDUST1
						fume.angle = P_RandomRange(1,360)*ANG1
						fume.colorized = true
						fume.color = SKINCOLOR_KETCHUP
						fume.scale = FRACUNIT*3
						P_InstaThrust(fume,fume.angle,(40*FRACUNIT))
						localquake(mo.battlen, FRACUNIT*6, 10)
					elseif time < 70
						for b = 1,4
							local fume = P_SpawnMobj(t.x,t.y,t.z,MT_DUMMY)
							fume.state = S_CDUST1
							fume.angle = P_RandomRange(1,360)*ANG1
							fume.colorized = true
							fume.color = SKINCOLOR_KETCHUP
							fume.scale = FRACUNIT*3
							P_InstaThrust(fume,fume.angle,(40*FRACUNIT))
						end
						for b = 1,2
							local rx = t.x + P_RandomRange(-64,64)*FRACUNIT
							local ry = t.y + P_RandomRange(-64,64)*FRACUNIT
							local fume = P_SpawnMobj(rx,ry,t.z,MT_DUMMY)
							fume.state = S_CDUST1
							fume.angle = P_RandomRange(1,360)*ANG1
							fume.colorized = true
							fume.color = SKINCOLOR_KETCHUP
							fume.scale = FRACUNIT*3
							fume.momz = P_RandomRange(15,35)*FRACUNIT
						end
					end
					if time < 70 and time >= 50
						local rx = t.x + P_RandomRange(-32,32)*FRACUNIT
						local ry = t.y + P_RandomRange(-32,32)*FRACUNIT
						local fiya = P_SpawnMobj(rx,ry,t.z,MT_DUMMY)
						fiya.sprite = SPR_FLME
						fiya.frame = I|FF_FULLBRIGHT
						fiya.scale = FRACUNIT*3
						fiya.fuse = 35
						fiya.momz = P_RandomRange(35,70)*FRACUNIT
						fiya.momx = P_RandomRange(-32,32)*FRACUNIT
						localquake(mo.battlen, FRACUNIT*24, 10)
					end
					if time < 50 and time >= 30
						localquake(mo.battlen, FRACUNIT*12, 10)
					end
					if time == 70
						damageObject(t)
						DoExplosion(t)
						localquake(mo.battlen, FRACUNIT*48, 15)
					end
					if time == 80
						localquake(mo.battlen, FRACUNIT*24, 10)
					end
					if time == 90
						localquake(mo.battlen, FRACUNIT*12, 5)
					end
					if time == 95
						localquake(mo.battlen, FRACUNIT*9, 5)
					end
					if time == 100
						localquake(mo.battlen, FRACUNIT*6, 5)
					end
					if time == 105
						localquake(mo.battlen, FRACUNIT*3, 10)
					end
				end
			end
			if timer == 105 + ((#hittargets - 1) * 5)
				return true
			end
		end,
}

attackDefs["encourage"] = {
		name = "Encourage",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 15,
		desc = "Encourages allies.\nRaises attack by 1 stage.",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

				local target = targets[i]

				if timer == 20 + (i-1)*8
					playSound(mo.battlen, sfx_courge)
					VFX_Play(target, VFX_SUMMON)
					buffStat(target, "atk")
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_ORANGE
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*8 and timer <= 50 + (i-1)*8

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS70
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_SUNSET
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_ORANGE
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 60 + (#targets-1)*16
				return true
			end
		end,
}

attackDefs["extend_hearts"] = {
		name = "Extend Hearts",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 30,
		desc = "Encourages allies with burning passion\nRaises Attack and agility by \n1 stage.",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

				local target = targets[i]

				if timer == 20 + (i-1)*8
					playSound(mo.battlen, sfx_courge)
					VFX_Play(target, VFX_SUMMON)
					buffStat(target, "atk")
					buffStat(target, "agi")
					
					BTL_logMessage(targets[1].battlen, "Attack and Agility up!")
					
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_RUBY
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*8 and timer <= 50 + (i-1)*8

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS70
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_RED
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_FLAME
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 60 + (#targets-1)*16
				return true
			end
		end,
}

attackDefs["burning_heart"] = {
		name = "Burning Heart",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 22,
		desc = "Charges up the user.\nRaises attack,defense and \nagility by 1 stage.",
		target = TGT_CASTER,
		implicit = "burningheart_thinker",
		superbuff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["atk"][1] >= 75
						and target.buffs["agi"][1] >= 75
						and target.buffs["def"][1] >= 75
							BTL_logMessage(targets[1].battlen, "You reached your limit.")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				S_StartSound(nil, sfx_burhea)
				ANIM_set(mo, mo.anim_special6, true)
			elseif timer >= 10 and timer <= 125
				summonAura(mo, SKINCOLOR_SUPERORANGE4)
				localquake(mo.battlen, FRACUNIT*5, 10)
			end	

			if timer == 90
				ANIM_set(mo, mo.anim_special7, true)
                buffStat(target, "atk")
                buffStat(target, "def")
                buffStat(target, "agi")
				if not mo.burninghearttimer
					mo.burninghearttimer = 4
				end
				BTL_logMessage(targets[1].battlen, "Attack up!\nDefense up!\nAgility up!")
				playSound(mo.battlen, sfx_buff)
			end
			
			if timer == 70
			or timer == 80
				for i = 1,16
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_SUPERORANGE4
					dust.scale = FRACUNIT*2
				end
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	
			
			if timer > 90 and timer < 125
				local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
				boom.state = S_QUICKBOOM1
				boom.colorized = true
				boom.color = SKINCOLOR_SUPERORANGE4
				boom.momz = P_RandomRange(0, 48)*FRACUNIT
				boom.scale = FRACUNIT*3/2
				localquake(mo.battlen, FRACUNIT*20, 10)
			end	

			if timer == 145
				return true
			end
		end,
}

attackDefs["burningheart_thinker"] = {
		name = "Burnt Out Heart",
		type = ATK_PASSIVE,
		implicit = "burningheart_reset",
		passive = PSV_STARTTURN,
		desc = "Thinker for Burning Heart",
		nometronome = true,
		norandom = true,
		anim = function(mo, targets, hittargets, timer)
			if timer == 1
				if not mo.burninghearttimer
					return true
				elseif mo.status_condition and mo.status_condition == (COND_HYPER or COND_SUPER)
					mo.burninghearttimer = 0 //Hyper Super cure it
					return true
				end
			end
			if timer > 1 and timer < 55
				if mo.burninghearttimer > 1
					if mo.burninghearttimer == 2
						BTL_logMessage(mo.battlen, mo.name.." will faint next turn!")
					else
						BTL_logMessage(mo.battlen, mo.name.."'s heart burns for "..(mo.burninghearttimer - 1).." more turns.")
					end
				elseif mo.burninghearttimer == 1
					if timer == 3
						cureStatus(mo)
						ANIM_set(mo, mo.anim_downloop, true)
						inflictStatus(mo,COND_SHOCK)
					end
					BTL_logMessage(mo.battlen, mo.name.."'s heart burned up!")
				end
			end
			if timer > 1 and timer <= 35 and mo.burninghearttimer ~= 1
				if not (leveltime%5)
					S_StartSound(nil, sfx_fire1) //sfx
				end
				for b = 1,3
					local boom = P_SpawnMobj(mo.x + P_RandomRange(-50, 50)*FRACUNIT, mo.y + P_RandomRange(-50, 50)*FRACUNIT, mo.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.colorized = true
					boom.color = SKINCOLOR_SUPERORANGE4
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
			end
			if timer == 55
				mo.burninghearttimer = $ - 1
				return true
			end
		end,
	}

attackDefs["burningheart_reset"] = {
		name = "Extinguished Heart",
		type = ATK_PASSIVE,
		nometronome = true,
		norandom = true,
		desc = "Reset Burning Heart timer on battle start",
		passive = PSV_STARTBATTLE,
		anim = function(mo, targets, hittargets, timer)
			dprint("Reset Burning Hearts timer for "..mo.name)
			mo.burninghearttimer = 0
		end,
	}


attackDefs["axle_rush"] = {
		name = "Axle Rush",
		type = ATK_STRIKE,
		power = 120,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		cost = 7,
		critical = 5,
		desc = "Light Damage to all enemies \nwith shockwaves",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #hittargets
				local color = SKINCOLOR_GOLD
				local target = hittargets[i]
				local time = timer - (i-1)*6

				if time == 1
					target.rolls = {}

				elseif time == 15
				or time == 20
				or time == 25	-- lazy
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = color
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_lydhit)
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle

				elseif time == 17
				or time == 22
				or time == 27

					if time == 22
					and not (i%2)

						local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
						d.sprite = SPR_THMP
						d.frame = C|FF_FULLBRIGHT
						d.scale = FRACUNIT/4
						d.destscale = FRACUNIT*3
						d.scalespeed = FRACUNIT/8
						d.fuse = TICRATE-10
						d.tics = d.fuse
						d.momz = FRACUNIT*2
						d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.color = color
					end

					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.scale = FRACUNIT/4
					s.sprite = SPR_SLAS
					s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
					s.destscale = FRACUNIT*9
					s.scalespeed = FRACUNIT
					s.tics = TICRATE/3


				elseif time == 19
				or time == 24
				or time == 29

					if time == 24
						damageObject(target)
						playSound(mo.battlen, sfx_bexpld)
						if not target.plyr
							createSplat(mo)
							createSplat(mo)
						end
						localquake(mo.battlen, FRACUNIT*10, 10)
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = color

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = color
					s.rollangle = target.rolls[#target.rolls]
				end
			end

			if timer == 55 + (#hittargets-1)*6
				return true
			end
		end,
}

attackDefs["brave_smash"] = {
		name = "Brave Smash",
		type = ATK_STRIKE,
		power = 60,
		accuracy = 90,
		critical = 2,
		target = TGT_ENEMY,
		cost = CST_HP,
		cost = 0,
		desc = "Attacks a enemy with a fiery dash.",
		anim_norepel = true,	-- do not bounce back our ANIMATION
		physical = true,	-- don't play the summoning anim for phys attacks, duh
		anim = 	function(mo, targets, hittargets, timer)
					local target = targets[1]
					local atarget = hittargets[1]
					if timer == 1
						ANIM_set(mo, mo.anim_special2, true)
						mo.reachedtarget = false	-- yeah we can use variables here that you like it or not :^)

						local cx = target.x + 168*cos(target.angle + ANG1*20)
						local cy = target.y + 168*sin(target.angle + ANG1*20)
						CAM_goto(server.P_BattleStatus[mo.battlen].cam, cx, cy, target.z + FRACUNIT*30, 70*FRACUNIT)
						CAM_angle(server.P_BattleStatus[mo.battlen].cam, R_PointToAngle2(cx, cy, target.x, target.y))
						S_StartSound(mo, sfx_msovd1)
					end

					local s = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DUMMY)
					s.state =  	S_FLAMEDASH1
					P_InstaThrust(mo, mo.angle, FRACUNIT*60)

					if not mo.reachedtarget

						if mo.anim ~= mo.anim_special2
							ANIM_set(mo, mo.anim_special2, true)
						end

						mo.angle = R_PointToAngle2(mo.x, mo.y, target.x, target.y)

						if R_PointToDist2(mo.x, mo.y, target.x, target.y) <= FRACUNIT*60

							damageObject(atarget)
							playSound(mo.battlen, sfx_bkpoof)
							mo.reachedtarget = timer

							for i=1,24
								local b = P_SpawnMobj(target.x, target.y, target.z+2*FRACUNIT, MT_DUMMY)
								b.momx = P_RandomRange(-32, 32)*FRACUNIT
								b.momy = P_RandomRange(-32, 32)*FRACUNIT
								b.momz = P_RandomRange(4, 16)*FRACUNIT
								b.state = S_AOADUST1
								b.frame = A|FF_FULLBRIGHT
								b.scale = FRACUNIT*3
								b.destscale = FRACUNIT/12
							end
							for i = 1, 4
								createSplat(mo)
							end
						end
					else

						if timer - mo.reachedtarget > 40
							return true
						end
					end
				end,
}

attackDefs["flare_butterfly"] = {
		name = "Flare Butterfly",
		type = ATK_FIRE,
		power = 140,
		accuracy = 90,
		costtype = CST_SP,
		cost = 16,
		status = COND_BURN,
		statuschance = 2,
		desc = "Orbal Art.\nMedium fire damage to all enemies\nMay burn.",
		target = TGT_ALLENEMIES,
		anim = 			function(mo, targets, hittargets, timer)

							local avgx = 0
							local avgy = 0

							for i = 1, #hittargets
								local t = hittargets[i]

								avgx = $+ t.x/FRACUNIT
								avgy = $+ t.y/FRACUNIT

								local time = timer - 10*(i-1)

								if time >= 20 and time <= 30
								and (time%5) == 0
								for i = 4,5
									local s = P_SpawnMobj(t.x + P_RandomRange(-128, 128)<<FRACBITS, t.y + P_RandomRange(-128, 128)<<FRACBITS, t.z + P_RandomRange(0, 192)<<FRACBITS, MT_DUMMY)
									s.state = S_QUICKBOOM1
									s.scale = $*2 + P_RandomRange(0, 65535)
									end
									playSound(mo.battlen, sfx_fire1)
								end
							end

							if timer == 40 + 10*(#hittargets-1)
								-- get average coords from what we had before
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT

								local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*128, MT_DUMMY)
								s.state = S_QUICKBOOM1
								s.scale = FRACUNIT*4
								playSound(mo.battlen, sfx_fire1)
							elseif timer == 50 + 10*(#hittargets-1)
								-- explode lol
								playSound(mo.battlen, sfx_fire2)
								avgx = ($/ #hittargets)*FRACUNIT
								avgy = ($/ #hittargets)*FRACUNIT
								local an = 0
								for i = 1, 32

									local s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.state = S_PFIRE1
									s.scale = $/2
									s.fuse = TICRATE*2
									P_InstaThrust(s, an*ANG1, 50<<FRACBITS)

									s = P_SpawnMobj(avgx, avgy, mo.z + FRACUNIT*32, MT_DUMMY)
									s.state = S_PFIRE1
									s.scale = $/4
									s.fuse = TICRATE*2
									P_InstaThrust(s, an*ANG1, 30<<FRACBITS)

									an = $ + (360/32)
								end

								for i = 1, #hittargets do
									damageObject(hittargets[i])
									DoExplosion(hittargets[i])
								end
							elseif timer == 100 + 10*(#hittargets-1)
								return true
							end
						end

}

attackDefs["volcanic_rave"] = {
		name = "Volcanic Rave",
		type = ATK_FIRE,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 5,
		cost = 12,
		desc = "Orbal Art.\nHeavy fire damage to a enemy\nMay burn.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 1
				playSound(mo.battlen, sfx_firbol)
				local firebol = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)	
				firebol.scale = 1 
				firebol.tics = 60
				firebol.destscale = FRACUNIT*5 
				firebol.sprite = SPR_THOK
				firebol.color = SKINCOLOR_RED
				firebol.frame = A|FF_TRANS20
				firebol.scalespeed = (FRACUNIT*6)/80
			end	
			
			
			if timer >= 20
			and timer < 50

				if timer == 20
					DoExplosion(target)
					localquake(mo.battlen, FRACUNIT*64, 10)
				end

				for i = 1, 12
					local boom = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z, MT_DUMMY)
					boom.state = S_QUICKBOOM1
					boom.momz = P_RandomRange(0, 48)*FRACUNIT
					boom.scale = FRACUNIT*3/2
				end
				localquake(mo.battlen, FRACUNIT*8, 1)

				if timer%4 == 0
					playSound(mo.battlen, sfx_fire1)
				end

			elseif timer == 50

				for i = 1, 32
					local smoke = P_SpawnMobj(target.x + P_RandomRange(-48, 48)*FRACUNIT, target.y + P_RandomRange(-48, 48)*FRACUNIT, target.z + P_RandomRange(0, 128)*FRACUNIT, MT_SMOKE)
					smoke.scale = FRACUNIT*4
					smoke.momz = P_RandomRange(3, 10)*FRACUNIT
				end

				damageObject(target)
				localquake(mo.battlen, FRACUNIT*17, 20)
				local smol = P_SpawnMobj(target.x, target.y, target.z, MT_SMOLDERING)
				smol.fuse = TICRATE*2
				smol.scale = FRACUNIT*3

			elseif timer == 80
				return true
			end
		end,
}

attackDefs["lord_inferno"] = {
		name = "Lord Inferno",
		type = ATK_FIRE,
		power = 350,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 5,
		cost = 24,
		desc = "Orbal Art.\nHeavy fire damage to all enemies\nMay burn.",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
			local spice = {SKINCOLOR_KETCHUP, SKINCOLOR_RED, SKINCOLOR_YELLOW, SKINCOLOR_FLAME, SKINCOLOR_SUNSET}
			//HELLO?? CRINGE DEPARTMENT?? [[Zoraxua]]!! IT'S FOR YOU!!
			//My cringe is to give all targets their own tables and cry if it doesnt work
			local timex = 170 //This is literally just bc I'm lazy and can't be bothered to constantly adjust timer for return true
			for i = 1, #hittargets
				local target = hittargets[i]
				if timer == 1
					target.puddles = {} //Setup
				end
				if timer < 35 //Make skybeams - I could make a beam that cuts horizontally but that seems like agony to piss with on multiple targets, sooo... SKYBEAMS
					local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
					local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
					for zt = 1,50
						local zh = target.z + (zt*8)*FRACUNIT
						local thok = P_SpawnMobj(rx,ry,zh, MT_THOK)
						thok.scale = FRACUNIT/4
						thok.tics = 1
						thok.color = spice[P_RandomRange(1,#spice)]
						local g = P_SpawnGhostMobj(thok)
						g.fuse = 5
						g.color = thok.color
					end
					local thok = P_SpawnMobj(rx,ry,target.floorz, MT_THOK)
					thok.scale = FRACUNIT*2
					thok.flags2 = $|MF2_SPLAT
					thok.tics = -1
					thok.color = spice[P_RandomRange(1,#spice)]
					target.puddles[#target.puddles+1] = thok //This is our target's puddle!
				end
				if timer < 70 and timer > 2
					for p = 1,#target.puddles
					local pud = target.puddles[p]
						if not ((timer+p)%5)
							local thok = P_SpawnMobj(pud.x,pud.y,pud.floorz, MT_THOK)
							thok.scale = FRACUNIT/4
							thok.tics = 35
							thok.color = spice[P_RandomRange(1,#spice)]
							thok.momx = P_RandomRange(-12,12)*FRACUNIT
							thok.momy = P_RandomRange(-12,12)*FRACUNIT
							thok.momz = P_RandomRange(5,12)*FRACUNIT
						end
					end
				end
				if timer > 60 and timer < 165 //To be safe
					for f = 1,#target.puddles
						local pud = target.puddles[f]
						if timer >= (69 + f) and timer < (104 + f)
							if timer == 69 + f
								pud.tics = 35
							end
							local boom = P_SpawnMobj(pud.x,pud.y,pud.floorz, MT_DUMMY)
							boom.state = S_QUICKBOOM1
							boom.colorized = true
							boom.color = pud.color
							boom.momz = P_RandomRange(0, 48)*FRACUNIT
							boom.scale = FRACUNIT*3/2
						end
					end
				end
				if timer == 120
					damageObject(target)
					if target.damagestate ~= DMG_MISS
					and target.damagestate ~= DMG_BLOCK
					and target.damagestate ~= DMG_DRAIN
						DoExplosion(target)
					end
				end
				if timer == timex - 1
					target.puddles = nil
				end
			end
			if timer == timex
				return true
			end//That's that
			
			if timer < 35
			S_StartSoundAtVolume(nil,sfx_lorinf,80)//Quiet bc we doing this every damn frame - Volume ranges from 0 - 250 iIrc
			elseif timer == 35
				playSound(mo.battlen, sfx_s237) //Lava puddles are settled and reacting
			end
			if timer >= 70 and timer < 140
				playSound(mo.battlen, sfx_s3k95) //Lava bursts
			end
			//Explosion sfx handles itself
		end,
}

attackDefs["crimson_ray"] = {
		name = "Crimson Ray",
		type = ATK_FIRE,
		power = 650,
		accuracy = 95,
		costtype = CST_SP,
		status = COND_BURN,
		statuschance = 5,
		cost = 12,
		desc = "Orbal Art.\nSevere fire damage to a enemy\nMay burn.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			if timer == 1
				local sun = P_SpawnMobj(target.x,target.y,target.z + FRACUNIT*256,MT_DUMMY)
				sun.sprite = SPR_FLAM
				sun.frame = M|FF_FULLBRIGHT
				sun.colorized = true
				sun.color = SKINCOLOR_KETCHUP
				sun.tics = -1
				mo.sun = sun
				playSound(mo.battlen, sfx_lorinf)
				DoExplosion(sun)
				
				mo.angle = R_PointToAngle2(mo.x,mo.y,target.x,target.y)
				local tgtx = target.x + 192*cos(target.angle)
				local tgty = target.y + 192*sin(target.angle)

			end
			if timer < 30
				local t = P_SpawnMobj (mo.sun.x,mo.sun.y,mo.sun.z,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT
				t.momz = (target.z - t.z)/10
				t.tics = 10
			elseif timer < 70
				local rx = target.x + P_RandomRange(-128,128)*FRACUNIT
				local ry = target.y + P_RandomRange(-128,128)*FRACUNIT
				local t = P_SpawnMobj (rx,ry,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT/2
				t.momz = (P_RandomRange(8,64)/4)*FRACUNIT
				t.tics = 20
			elseif timer < 100
				local rangle = P_RandomRange(0, 359)
				local cx = target.x + 128*cos(target.angle + ANG1*(rangle))
				local cy = target.y + 128*sin(target.angle + ANG1*(rangle))
					
				local thok = P_SpawnMobj(cx, cy, target.z, MT_DUMMY)	
				thok.sprite = SPR_FLAM
				thok.frame = M|FF_FULLBRIGHT
				thok.colorized = true
				thok.color = SKINCOLOR_KETCHUP
				thok.frame = A|FF_FULLBRIGHT
				thok.tics = 15
				thok.destscale = 1
				thok.scalespeed = (FRACUNIT/2)/15
				thok.scale = FRACUNIT/2
				thok.momx = (target.x - thok.x)/15
				thok.momy = (target.y - thok.y)/15
				thok.momz = (target.z - thok.z)/15
			elseif timer < 120
				local t = P_SpawnMobj (target.x,target.y,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT*3
				t.momz = FRACUNIT*20
				t.tics = 20
			elseif timer < 140
				local t = P_SpawnMobj (target.x,target.y,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT*2
				t.momz = FRACUNIT*20
				t.tics = 20
			elseif timer < 160
				local t = P_SpawnMobj (target.x,target.y,target.floorz,MT_THOK)
				t.sprite = SPR_FLAM
				t.frame = M|FF_FULLBRIGHT
				t.colorized = true
				t.color = SKINCOLOR_KETCHUP
				t.scale = FRACUNIT
				t.momz = FRACUNIT*20
				t.tics = 20
			end
			if timer > 120 and timer < 170
				local rndx = target.x + (P_RandomRange(-24,24)*target.scale)
				local rndy = target.y + (P_RandomRange(-24,24)*target.scale)
				local rndz = target.z + (P_RandomRange(-2,48)*target.scale)
				local adrip = P_SpawnMobj(rndx,rndy,rndz,MT_WATERDROP)
				if adrip and adrip.valid //Yeah I just used Samalam's Acid drips here lol
					adrip.colorized = true
					adrip.color = SKINCOLOR_KETCHUP
					adrip.frame = $|FF_TRANS10
					adrip.flags = $1|MF_NOCLIPTHING
				end
			end
			if timer == 30
				for i = 1,72 //Woo reusing my own shtuff for cool speed
					local icegas = P_SpawnMobj(target.x,target.y,target.z,MT_DUMMY)
					icegas.state = S_CDUST1//Shameless, I know
					icegas.angle = target.angle + ((ANG1 * 5) * i)
					icegas.colorized = true
					icegas.color = SKINCOLOR_RED
					icegas.scale = FRACUNIT*2
					P_InstaThrust(icegas,icegas.angle,(60*FRACUNIT))
				end
			end
			if timer == 100
				playSound(mo.battlen, sfx_fortun)
				mo.sun.destscale = 1
				mo.sun.scalespeed = mo.sun.scale/20
				mo.sun.tics = 20
				DoExplosion(target)
				damageObject(target)
				localquake(mo.battlen, FRACUNIT*64, 30)
			end
			if timer == 130
				localquake(mo.battlen, FRACUNIT*32, 10)
			end
			if timer == 140
				localquake(mo.battlen, FRACUNIT*16, 10)
			end
			if timer == 150
				localquake(mo.battlen, FRACUNIT*8, 10)
			end
			if timer == 160
				localquake(mo.battlen, FRACUNIT*4, 10)
			end
			if timer == 170
				return true
			end
		end,
}

attackDefs["stun_break"] = {
		name = "Stun Break",
		type = ATK_STRIKE,
		power = 410,
		accuracy = 90,
		costtype = CST_HPPERCENT,
		technical = COND_FREEZE,
		status = COND_SHOCK,
		statuschance = 5,
		cost = 13,
		critical = 5,
		desc = "Shocks with high-power current to \none enemy causing Heavy Strike\nDamage.May Shock",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 10
				playSound(mo.battlen, sfx_zio2)
				playSound(mo.battlen, sfx_s3k40)
			end	
			
			if timer >= 10 and timer <= 40
				local orb = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
				orb.sprite = SPR_DELK
				orb.frame = P_RandomRange(0, 7)|FF_FULLBRIGHT
				orb.color = SKINCOLOR_CYAN
				orb.destscale = FRACUNIT*7
				orb.scalespeed = FRACUNIT/4
				orb.tics = TICRATE/8
			end
			
			if timer >= 10 and timer <= 40
                local boom = P_SpawnMobj(target.x, target.y, target.z,MT_DUMMY)
                boom.scale = FRACUNIT*1
				boom.sprite = SPR_MAGN
				boom.colorized = true
				boom.color = SKINCOLOR_CYAN
				boom.frame = A|FF_TRANS70|FF_ANIMATE
				boom.tics = TICRATE/8
			end
			
			if timer == 10
				playSound(mo.battlen, sfx_pstop)
				localquake(mo.battlen, 7*FRACUNIT, 5)
				for i=1,16
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-8, 8)*FRACUNIT
					b.momy = P_RandomRange(-8, 8)*FRACUNIT
					b.momz = P_RandomRange(-8, 8)*FRACUNIT
					b.state = S_AOADUST1
					b.frame = A|FF_FULLBRIGHT
					b.scale = FRACUNIT*3
					b.destscale = FRACUNIT/12
				end
			end
			
			if timer == 40
				damageObject(target)
				playSound(mo.battlen, sfx_lydhit)
				
			elseif timer == 60
				return true
			end
		end,
	}