freeslot("sfx_likatk", "sfx_likdo", "sfx_arcdrn" ,"SPR_ZODI", "sfx_zodiac", "sfx_zodac2", 
"SPR_ADSL", "sfx_adashd")

attackDefs["adamantine_shield"] = {
	name = "Adamantine Shield",
	type = ATK_SUPPORT,
	costtype = CST_SP,
	cost = 36,
	desc = "Orbal Art.\nGives a physical barrier that\nrepels to 1 ally",
	target = TGT_ALLY,
	superbuff = true,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]
		local avgx = 0
		local avgy = 0
		
		if timer == 10
			playSound(mo.battlen, sfx_adashd)
		end
		
		if timer == 10
			local x = target.x + 48*cos(target.angle)
			local y = target.y + 48*sin(target.angle)
			local m = P_SpawnMobj(x, y, target.z, MT_DUMMY)
			m.sprite = SPR_ADSL
			m.scale = FRACUNIT*1
			m.frame = A|FF_TRANS10|FF_PAPERSPRITE
			m.angle = target.angle + ANG1*90
			m.tics = 80
			target.shield = m
		elseif timer == 60
			target.shield.frame = A|FF_TRANS50|FF_PAPERSPRITE
		elseif timer == 65
			target.shield.frame = A|FF_TRANS60|FF_PAPERSPRITE
		elseif timer == 70	
			target.shield.frame = A|FF_TRANS70|FF_PAPERSPRITE
		elseif timer == 75	
			target.shield.frame = A|FF_TRANS80|FF_PAPERSPRITE
		elseif timer == 80	
			target.shield.frame = A|FF_TRANS90|FF_PAPERSPRITE	
		end	

		
		if timer >= 10 and timer <= 80
			for i = 1,3
				local thok = P_SpawnMobj(target.x + P_RandomRange(-30, 30)*FRACUNIT, target.y + P_RandomRange(-30, 30)*FRACUNIT, target.z, MT_DUMMY)
				thok.flags = MF_NOBLOCKMAP
				thok.color = SKINCOLOR_ORANGE
				if timer%2 then thok.color = SKINCOLOR_APRICOT end
				thok.frame = A
				thok.tics = 35
				thok.scale = FRACUNIT/2
				thok.scalespeed = FRACUNIT/32
				thok.destscale = 1
				thok.momz = P_RandomRange(5, 10)*FRACUNIT
				thok.momx = P_RandomRange(-5, 5)*FRACUNIT
				thok.momy = P_RandomRange(-5, 5)*FRACUNIT
			end
		end	
		
		if timer >= 10 and timer <= 80
		and (timer%5) == 0
			for i = 1, #hittargets
				local t = hittargets[i]
				avgx = $+ t.x/FRACUNIT
				avgy = $+ t.y/FRACUNIT
				local s = P_SpawnMobj(t.x + P_RandomRange(-28, 28)<<FRACBITS, t.y + P_RandomRange(-28, 28)<<FRACBITS, t.z + P_RandomRange(0, 50)<<FRACBITS, MT_DUMMY)
				s.color = SKINCOLOR_WHITE
				s.state = S_MEGISTAR1
				s.scale = FRACUNIT*1
			end	
		end	
		
		if timer == 81
			local thok = P_SpawnMobj(target.x, target.y, target.z+5*FRACUNIT, MT_DUMMY)
			thok.state = S_INVISIBLE
			thok.tics = 1
			A_OldRingExplode(thok, MT_SUPERSPARK)
			target.tetrakarn = true
			BTL_logMessage(targets[1].battlen, target.name.." has\na physical barrier!")
		end
		
		if timer == 105
			return true
		end
	end,	

}

attackDefs["zodiac"] = {
		name = "Zodiac",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 12,
		desc = "Orbal Art.\nRaises physical attack and defence\n to all allies by 1 stage",
		target = TGT_ALLALLIES,
		buff = true,
		anim = function(mo, targets, hittargets, timer)
		
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)*FRACUNIT
			avgy = ($/#hittargets)*FRACUNIT
			
			if timer == 100
				playSound(mo.battlen, sfx_lydchr)
			end	
			
			if timer == 140
				playSound(mo.battlen, sfx_buff)
			end	
			
			if timer == 1
				mo.megi = {}
			elseif timer >= 10 and timer <= 90 and timer%2 == 0
				if timer == 20
					playSound(mo.battlen, sfx_zodiac)
					P_StartQuake(FRACUNIT, 120)
					mo.charge = P_SpawnMobj(avgx, avgy, mo.z + 200*FRACUNIT, MT_THOK)
					local charge = mo.charge
					charge.state = S_ZODIAC_1
					charge.flags = MF_NOGRAVITY
					charge.fuse = 121
					charge.scale = FRACUNIT*3/4
					charge.destscale = FRACUNIT*3
					charge.scalespeed = FRACUNIT/24
				end
				local cam = server.P_BattleStatus[mo.battlen].cam
				local hang = cam.angle + ANG1*90
				local vang = ANG1*P_RandomRange(1,359)
				local dist = 300
				local x, y = 0, 0
				while x > -400 and x < 400 and y > -400 and y < 400
					x = mo.x + P_RandomRange(-500, 500)*FRACUNIT
					y = mo.y + P_RandomRange(-500, 500)*FRACUNIT
				end
				local z = (mo.z + 200*FRACUNIT) + (P_RandomRange(-200,200))*FRACUNIT
				local ol = P_SpawnMobj(x, y, z, MT_THOK)
				ol.state = S_MEGITHOK
				ol.scale = FRACUNIT/4
				ol.fuse = 25
				ol.momx = $ + (avgx-ol.x)/32
				ol.momy = $ + (avgy-ol.y)/32
				ol.momz = $ + ((mo.z+200*FRACUNIT)-ol.z)/32
			elseif timer == 100
				P_StartQuake(FRACUNIT*5, 10)
				playSound(mo.battlen, sfx_zodac2)
				local charge = mo.charge
				charge.destscale = 1
				charge.scalespeed = FRACUNIT/8
				for i = 1, 16
					local ol = P_SpawnMobj(charge.x, charge.y, charge.z, MT_THOK)
					ol.state = S_MEGITHOK
					ol.fuse = 40
					ol.scale = FRACUNIT/4
					ol.momx = FRACUNIT*P_RandomRange(-20,20)
					ol.momy = FRACUNIT*P_RandomRange(-20,20)
					ol.flags = MF_NOBLOCKMAP
				end
			elseif timer > 100 and timer < 140
				for i = 1, #hittargets
					local target = hittargets[i]
					summonAura(target, SKINCOLOR_GOLD)
				end
			elseif timer == 140
				for i = 1, #hittargets
					local target = hittargets[i]
					buffStat(target, "atk")
					buffStat(target, "def")
					BTL_logMessage(target.battlen, "Attack and Defense up!")
					for i = 1,8
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_GOLD
						dust.scale = FRACUNIT*2
					end
				end
			elseif timer > 140 and timer <= 170
				for i = 1, #hittargets
					local target = hittargets[i]
					if leveltime%2 == 0
						for i = 1,8

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_ZODI
							thok.frame = B|FF_FULLBRIGHT|TR_TRANS50
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_GOLD
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 4
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_ZODI
						thok.frame = A|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_GOLD
						thok.tics = P_RandomRange(10, 35)
					end
				end
			elseif timer == 200
				return true
			end
		end,
}

attackDefs["cherubicsmile"] = {
		name = "Cherubic Smile",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 15,
		desc = "Cheers up a ally increasing\ncritical hit rate",
		target = TGT_ALLY,
		buff = true,
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.buffs["crit"][1] >= 75
							BTL_logMessage(targets[1].battlen, "Limit reached!")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]

			if timer == 20
				playSound(mo.battlen, sfx_courge)
				VFX_Play(target, VFX_SUMMON)
				buffStat(target, "crit")
				for i = 1,16
					local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					dust.angle = ANGLE_90 + ANG1* (22*(i-1))
					dust.state = S_CDUST1
					P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
					dust.color = SKINCOLOR_ROSY
					dust.scale = FRACUNIT*2
				end

			elseif timer > 20 and timer <= 50

				if leveltime%2 == 0
					for i = 1,16

						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.state = S_CDUST1
						thok.momz = P_RandomRange(3, 10)*FRACUNIT
						thok.color = SKINCOLOR_ROSY
						thok.tics = P_RandomRange(10, 35)
						thok.scale = FRACUNIT*3/2
					end
				end

				for i = 1, 8
					local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
					thok.sprite = SPR_SUMN
					thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
					thok.momz = P_RandomRange(6, 16)*FRACUNIT
					thok.color = SKINCOLOR_ROSY
					thok.tics = P_RandomRange(10, 35)
				end
			elseif timer == 60
				return true
			end
		end,
}

attackDefs["archdrain"] = {
		name = "Arch Drain",
		type = ATK_ALMIGHTY,
		power = 270,
		accuracy = 999,
		costtype = CST_SP,
		cost = 6,
		showsp = true,
		desc = "Orbal Art.\nDrains a Enemy's SP",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
					local target = hittargets[1]
					
					if timer >= 20 and timer <= 40
					mo.fuckursp = P_RandomRange(50, 100)
					local imfuckingtired = mo.fuckursp

                        if timer == 20
                            playSound(mo.battlen, sfx_arcdrn)
                        elseif timer == 30
                             damageSP(target, imfuckingtired)
						end

						for i = 1,2
							local thok = P_SpawnMobj(target.x, target.y, target.z+mo.height/2, MT_DUMMY)
							thok.color = SKINCOLOR_SAPPHIRE
							thok.momx = P_RandomRange(-10, 10)*FRACUNIT
							thok.momy = P_RandomRange(-10, 10)*FRACUNIT
							thok.momz = P_RandomRange(-10, 10)*FRACUNIT
							thok.scale = FRACUNIT/10
							thok.destscale = FRACUNIT*2
						end

					elseif timer >= 50 and timer <= 70

                        if timer == 60
                        and target ~= mo
                            mo.atk_attacker = mo
                            playSound(mo.battlen, sfx_lsheal)
                            damageSP(mo, -(mo.fuckursp))
                        end

						local h_angle = P_RandomRange(1, 359)*ANG1
						local v_angle = P_RandomRange(1, 359)*ANG1
						local dist = 256
						local spd = P_RandomRange(40, 50)

						local s_x = mo.x+ dist*FixedMul(cos(h_angle), cos(v_angle))
						local s_y = mo.y+ dist*FixedMul(sin(h_angle), cos(v_angle))
						local s_z = (mo.z+mo.height/2)+ dist* sin(v_angle)

						local s = P_SpawnMobj(s_x, s_y, s_z, MT_DUMMY)

						s.frame = A
						s.color = SKINCOLOR_SAPPHIRE
						s.scale = FRACUNIT*3/2
						s.destscale = FRACUNIT/5
						s.target = target
						s.tics = 10
						s.momx = (mo.x - s.x)/10
						s.momy = (mo.y - s.y)/10
						s.momz = (mo.z - s.z)/10

					elseif timer == 110
						return true
					end
				end,
}

attackDefs["antidote"] = {
		name = "Antidote",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Poison",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_POISON
                            BTL_logMessage(targets[1].battlen, target.name.." is not poisoned")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_POISON
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["relaxant"] = {
		name = "Relaxant",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Shock",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_SHOCK
                            BTL_logMessage(targets[1].battlen, target.name.." is not paralyzed")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_SHOCK
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["tape"] = {
		name = "Insulating Tape",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Silence",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_SILENCE
                            BTL_logMessage(targets[1].battlen, target.name.." is not silenced")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_SILENCE
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["spray"] = {
		name = "Cooling Spray",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Burn",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_BURN
                            BTL_logMessage(targets[1].battlen, target.name.." is not burning")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_BURN
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["warmer"] = {
		name = "Warmer",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Freeze",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_FREEZE
                            BTL_logMessage(targets[1].battlen, target.name.." is not frozen")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_FREEZE
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["eye"] = {
		name = "Eye Drop",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Dizzy",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_DIZZY
                            BTL_logMessage(targets[1].battlen, target.name.." doesn't feel dizzy...")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_DIZZY
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["mint"] = {
		name = "Mint Drop",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Sleep",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_SLEEP
                            BTL_logMessage(targets[1].battlen, target.name.." is not sleeping...")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_SLEEP
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["sedative"] = {
		name = "Sedative",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Brainwash",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_BRAINWASH
                            BTL_logMessage(targets[1].battlen, target.name.." is not brainwashed")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition == COND_BRAINWASH
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["salts"] = {
		name = "Smelling Salts",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 0,
		nometronome = true,
		norandom = true,
		desc = "Cures Rage/Hex",
		target = TGT_ALLY,
		nocast =     function(targets, n)    -- we can't cast this skill if this function returns true
                        local target = targets[n]
                        if target.status_condition and target.status_condition ~= COND_RAGE and target.status_condition ~= COND_FEAR
                            BTL_logMessage(targets[1].battlen, target.name.." is not angry or scared")
                            return true
                        elseif not target.status_condition
                            BTL_logMessage(targets[1].battlen, target.name.." has no ailments")
                            return true
                        end
                    end,
		anim = function(mo, targets, hittargets, timer)
			local colors = {SKINCOLOR_EMERALD}

			local target = hittargets[1]
			if timer == 20
				playSound(mo.battlen, sfx_curia)
				for j = 1, 16
					local orb = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					orb.momx = P_RandomRange(-16, 16)<<FRACBITS
					orb.momy = P_RandomRange(-16, 16)<<FRACBITS
					orb.momz = P_RandomRange(-16, 16)<<FRACBITS
					orb.destscale = 0
					orb.frame = A
					orb.color = colors[P_RandomRange(1, #colors)]
				end
				if target.status_condition and target.status_condition ~= COND_RAGE and target.status_condition ~= COND_HEX
				else
					cureStatus(target)
				end
				BTL_logMessage(targets[1].battlen, "Ailment cured")
			end
			if timer == TICRATE*3/2
				return true
			end
		end,
}

attackDefs["scope"] = {
		name = "Battle Scope",
		type = ATK_SUPPORT,
		costtype = CST_EP,
		nometronome = true,
		norandom = true,
		cost = 1,
		desc = "Analyze 1 target, revealing\ntheir affinities.",
		target = TGT_ENEMY,
		norepel = true,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local btl = server.P_BattleStatus[mo.battlen]

			if mo.enemy
				return true	-- NO.
			end

			if timer == 15

				if not btl.saved_affs[target.enemy]
					playSound(mo.battlen, sfx_bascp)
					btl.saved_affs[target.enemy] = {0, 0, false}	-- failsafe?
				end
				btl.saved_affs[target.enemy][1] = 2147483647	-- INT32_MAX
				btl.saved_affs[target.enemy][2] = 2147483647	-- INT32_MAX
				btl.saved_affs[target.enemy][3] = true	-- stats

				playSound(mo.battlen, sfx_bascp)
				local t = P_SpawnMobj(target.x, target.y, target.z + target.height/2, MT_THOK)
				t.tics = -1
				t.sprite = SPR_ANLY
				t.frame = FF_FULLBRIGHT
				t.scale = FRACUNIT*5/2
				t.fuse = TICRATE*2


				local g = P_SpawnGhostMobj(t)
				t.destscale = $*4
				t.scalespeed = $*4
				t.momz = FRACUNIT*4
				t.fuse = TICRATE/2
			end

			if timer >= 30
				if mo.control.mo.P_inputs[BT_JUMP] == 1
				and not mo.anl_closetimer

					mo.anl_closetimer = TICRATE

				end

				if mo.anl_closetimer
					mo.anl_closetimer = $-1
					if not mo.anl_closetimer

						mo.anl_closetimer = nil
						-- give me another turn
						local i = #btl.turnorder+1
						while i > 1
							btl.turnorder[i] = btl.turnorder[i-1]
							i = $-1
						end
						return true
					end
				end
			end

		end,

		-- hudfunc2 is layered above the regular UI
		hudfunc2 = function(v, mo, timer)

			local target = mo.targets[1]
			if timer > TICRATE and target.enemy

					local cmd = {
						{BUTT_A, "Close"},
					}

				if mo.anl_closetimer
					local t = mo.anl_closetimer - TICRATE/2
					if t > 0
						v.drawScaled(160<<FRACBITS, 100<<FRACBITS, max(0, min(64, t))*FRACUNIT/2, v.cachePatch("H_1M_B"), V_50TRANS)
						drawStats(v, target, max(t, -8), 1, 0, cmd)
					end
				else
					local t = timer - TICRATE
					v.drawScaled(160<<FRACBITS, 100<<FRACBITS, max(0, min(64, t))*FRACUNIT/2, v.cachePatch("H_1M_B"), V_50TRANS)
					drawStats(v, target, max(t, -8), 1, 0, cmd)
				end
			end
		end,

}

attackDefs["zeram_powder"] = {
		name = "Zeram Powder",
		type = ATK_HEAL,
		costtype = CST_SP,
		cost = 31651620,
		desc = "Revives a ally with full HP and SP.",
		norandom = true,	-- Don't allow this move to be selected in random pvp skills
		target = TGT_DEAD,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			local cam = server.P_BattleStatus[mo.battlen].cam
			-- first of all, get this boy back in our party
			if timer == 1
				revivePlayer(target)
				mo.minido = {} //Megidola support: making things
				target.landedonce = false
			end
			local avgx, avgy = 0, 0
			for i = 1, #hittargets
				avgx = $ + hittargets[i].x/FRACUNIT
				avgy = $ + hittargets[i].y/FRACUNIT
			end
			avgx = ($/#hittargets)	*FRACUNIT
			avgy = ($/#hittargets)	*FRACUNIT
			
			if timer == 5
				local cx = mo.x + 192*cos(mo.angle)
				local cy = mo.y + 192*sin(mo.angle)
				P_TeleportMove(cam, cx, cy, mo.z + FRACUNIT*16)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, mo.x, mo.y)
				summonAura(mo, SKINCOLOR_TEAL)
				ANIM_set(mo, mo.anim_evoker, true)
				ANIM_set(target, target.anim_downloop, true)
			elseif timer == 25
				local cx = target.x + 384*cos(target.angle)
				local cy = target.y + 384*sin(target.angle)
				P_TeleportMove(cam, cx, cy, target.z + FRACUNIT*24)
				server.P_BattleStatus[mo.battlen].cam.angle = R_PointToAngle2(cam.x, cam.y, target.x, target.y)
				playSound(mo.battlen, sfx_thelas)
			elseif timer < 60
			and timer > 25
				local ran = P_RandomRange(0, 359)*ANG1
				local dist = 256

				mo.minido[#mo.minido+1] = P_SpawnMobj(avgx + dist*cos(ran), avgy + dist*sin(ran), mo.z + 256*FRACUNIT, MT_DUMMY)
				local s = mo.minido[#mo.minido]
				s.angle = ran
				s.state = S_MEGITHOK
				s.scale = $/5
				s.extravalue1 = dist
				s.colorized = true
				s.color = SKINCOLOR_ORANGE
			end
			if timer <= 115
				for i = 1, #mo.minido
					if timer < 115
					local s = mo.minido[i]
					s.angle = $ + ANG1*12
					s.extravalue1 = max(0, $ - 6)

					local x = avgx + s.extravalue1*cos(s.angle)
					local y = avgy + s.extravalue1*sin(s.angle)
					local sz = s.z - FRACUNIT*6
					if s.z > target.z + 16*FRACUNIT
						P_TeleportMove(s, x, y, sz)
					else
						P_TeleportMove(s, x, y, s.z)
						s.destscale = 1
						s.scalespeed = FRACUNIT/20
					end
					elseif timer == 115
						local s = mo.minido[i]
						s.fuse = 2
					end
				end
			end
			if timer == 115
				local heals = target.maxhp
				damageObject(target, -heals)
				damageSP(target, -target.maxsp)
				playSound(mo.battlen, sfx_tear)
				playSound(mo.battlen, sfx_lsheal)
				ANIM_set(target, target.anim_revive, true)
				target.momz = 6*FRACUNIT
				for i = 1, 64
					local thok = P_SpawnMobj(target.x + P_RandomRange(-40, 40)*FRACUNIT, target.y + P_RandomRange(-40, 40)*FRACUNIT, target.z, MT_DUMMY)
					thok.flags = MF_NOBLOCKMAP
					thok.color = SKINCOLOR_ORANGE
					thok.frame = A
					thok.tics = 50
					thok.scale = (P_RandomRange(1, 10)*FRACUNIT)/8
					thok.scalespeed = FRACUNIT/50
					thok.destscale = 1
					thok.momz = P_RandomRange(3, 12)*FRACUNIT
					thok.momx = P_RandomRange(-15, 15)*FRACUNIT
					thok.momy = P_RandomRange(-15, 15)*FRACUNIT
				end
			end
			if timer > 115 and P_IsObjectOnGround(target) and not target.landedonce
				ANIM_set(target, target.anim_stand_hurt, true)
				target.landedonce = true
			end
			if timer == 165
				target.landedonce = nil
				mo.minido = nil
				return true
			end
		end,
}


attackDefs["genesic_barrier"] = {
	name = "Genesic Barrier",
	type = ATK_SUPPORT,
	power = 0,
	accuracy = 95,
	costtype = CST_SP,
	cost = 29,
	desc = "Orbal Art.\nGives Curse Resistance to a ally",
	target = TGT_ALLY,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1]

		if timer == 10
			playSound(mo.battlen, sfx_hamas2)
		end

		if timer <= 30
			local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
			thok.state = S_MEGITHOK
			thok.momz = P_RandomRange(3, 10)*FRACUNIT
			thok.color = SKINCOLOR_YELLOW
			thok.fuse = 55 - timer
			thok.tics = P_RandomRange(10, 35)
			thok.scale = FRACUNIT/2
		end

		if timer == 20
			playSound(mo.battlen, sfx_buff)
			buffStat(target, ATK_CURSE)
			BTL_logMessage(targets[1].battlen, target.name.." now is\nneutral in Curse!")
			for i = 1, 32
				local thok = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
				thok.state = S_CDUST1
				thok.momz = P_RandomRange(3, 10)*FRACUNIT
				thok.color = SKINCOLOR_RED
				thok.scale = FRACUNIT*3/2
				thok.tics = TICRATE
				
				P_InstaThrust(thok, i*10*ANG1, 20*FRACUNIT)
			end
		elseif timer == 62
			return true
		end
	end,
}

attackDefs["sp_charge1"] = {
		name = "SP Charge",
		type = ATK_HEAL,
		target = TGT_ALLY,
		costtype = CST_SP,
		cost = 0,
		norandom = true,	-- Don't allow this move to be selected in random pvp skills
		power = 50,
		showsp = true,	-- tell the game to display sp bars
		desc = "50 SP recovery to 1 ally.",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.sp >= target.maxsp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 5
					playSound(mo.battlen, sfx_spheal)
				end

				if timer <= 30
					local thok = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.z+P_RandomRange(0, 0)*FRACUNIT, MT_DUMMY)
					thok.state = S_MEGISTAR1
					thok.momz = (P_RandomRange(4, 8)/4)*FRACUNIT
					thok.color = SKINCOLOR_MAGENTA
					thok.tics = P_RandomRange(10, 25)
					thok.scale = FRACUNIT*3/2
				end

				if timer == 40
					damageSP(target, -50)
					playSound(mo.battlen, sfx_lsheal)
				elseif timer == 75
					return true
				end
		end,
}

attackDefs["sp_charge2"] = {
		name = "SP Charge II",
		type = ATK_HEAL,
		target = TGT_ALLY,
		costtype = CST_SP,
		cost = 0,
		norandom = true,	-- Don't allow this move to be selected in random pvp skills
		power = 100,
		showsp = true,	-- tell the game to display sp bars
		desc = "100 SP recovery to 1 ally.",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.sp >= target.maxsp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
				local target = hittargets[1]

				if timer == 5
					playSound(mo.battlen, sfx_spheal)
				end

				if timer <= 30
					local thok = P_SpawnMobj(target.x+P_RandomRange(-20, 20)*FRACUNIT, target.y+P_RandomRange(-20, 20)*FRACUNIT, target.z+P_RandomRange(0, 0)*FRACUNIT, MT_DUMMY)
					thok.state = S_MEGISTAR1
					thok.momz = (P_RandomRange(4, 8)/4)*FRACUNIT
					thok.color = SKINCOLOR_MAGENTA
					thok.tics = P_RandomRange(10, 25)
					thok.scale = FRACUNIT*3/2
				end

				if timer == 40
					damageSP(target, -100)
					playSound(mo.battlen, sfx_lsheal)
				elseif timer == 75
					return true
				end
		end,
}

attackDefs["sp_charge3"] = {
		name = "SP Charge III",
		type = ATK_HEAL,
		target = TGT_ALLY,
		costtype = CST_SP,
		cost = 0,
		norandom = true,	-- Don't allow this move to be selected in random pvp skills
		power = 999,
		showsp = true,	-- tell the game to display sp bars
		desc = "Full SP recovery to 1 ally.",
		nocast = 	function(targets, n)	-- we can't cast this skill if this function returns true
						local target = targets[n]
						if target.sp >= target.maxsp
							BTL_logMessage(targets[1].battlen, "No further effects.")
							return true
						end
					end,
		anim = function(mo, targets, hittargets, timer)
				local time = timer

				local target = hittargets[1]
				
				if time >= 20
				and time < 50
					if time == 26
						playSound(mo.battlen, sfx_teara)
					end
					if time < 50
						for i = 1, 2
							local r = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z + P_RandomRange(128,-128)*FRACUNIT, MT_THOK)
							r.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							r.sprite = SPR_BFUC
							r.colorized = true
							r.color = SKINCOLOR_MAGENTA
							r.frame = A
							r.fuse = 20
							r.scale = (FRACUNIT*2)
							r.momx = (target.x - r.x)/20
							r.momy = (target.y - r.y)/20
							r.momz = (target.z - r.z)/20
							r.destscale = 1
							r.scalespeed = (FRACUNIT*2)/20
							local q = P_SpawnMobj(target.x + P_RandomRange(128,-128)*FRACUNIT,target.y + P_RandomRange(128,-128)*FRACUNIT, target.z, MT_THOK)
							q.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT
							q.sprite = SPR_BFUC
							q.frame = D
							q.fuse = 55
							q.colorized = true
							q.color = SKINCOLOR_MAGENTA
							q.tics = q.fuse
							q.scale = (FRACUNIT*2)/3
							q.momz = (P_RandomRange(5, 15))*FRACUNIT
							end
						end

				elseif time == 70
					local b = P_SpawnMobj(target.x, target.y, target.z + 16*FRACUNIT, MT_THOK)
					b.fuse = 35
					b.scale = FRACUNIT/4
					b.destscale = 10*FRACUNIT
					b.scalespeed = ((39*FRACUNIT)/4)/35
					b.frame = A|FF_FULLBRIGHT
					b.color = SKINCOLOR_MAGENTA
					P_SpawnMobj(target.x, target.y, target.z, MT_IVSP)
					playSound(mo.battlen, sfx_lsheal)
					damageSP(target, -target.maxsp)
				end

			if timer == 110
				return true
			end
		end,
}

attackDefs["link_attack"] = {
		name = "Link Attack!",
		type = ATK_SLASH,
		power = 50,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		cost = 10,
		critical = 3,
		link = true,
		desc = "Light Slash damage to\none enemy. Following allied attacks\ngain Link follow-ups.",
		target = TGT_ENEMY,
		anim = function(mo, targets, hittargets, timer)
			local target = hittargets[1]
			
			if timer == 5
			playSound(mo.battlen, sfx_likatk)
			end

			if timer == 15
				local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
				s.state = S_SLASHING_1_1
				s.color = SKINCOLOR_WHITE
				s.scale = FRACUNIT*3/2
				playSound(mo.battlen, sfx_slash)

			elseif timer == 17
				local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
				d.sprite = SPR_THMP
				d.frame = C|FF_FULLBRIGHT
				d.scale = FRACUNIT/4
				d.destscale = FRACUNIT*3
				d.scalespeed = FRACUNIT/8
				d.fuse = TICRATE-10
				d.tics = d.fuse
				d.momz = FRACUNIT*2
				d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
				d.color = SKINCOLOR_WHITE
			end

			if timer == 19

				damageObject(target)
				playSound(mo.battlen, sfx_likdo)
				if not target.plyr
					createSplat(mo)
					createSplat(mo)
				end
				localquake(mo.battlen, FRACUNIT*10, 10)
				
				for i=1,20
					local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
					b.momx = P_RandomRange(-8, 8)*FRACUNIT
					b.momy = P_RandomRange(-8, 8)*FRACUNIT
					b.momz = P_RandomRange(-8, 8)*FRACUNIT
					b.state = S_SSPK1
				end		
				

				local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
				s.sprite = SPR_SLSH
				s.frame = I|FF_FULLBRIGHT
				s.scale = FRACUNIT/2
				s.destscale = FRACUNIT*4
				s.scalespeed = FRACUNIT/3
				s.color = SKINCOLOR_WHITE

			elseif timer == 45
				target.slashsprite = nil
				return true
			end
		end,
}

attackDefs["gale"] = {
		name = "Gale",
		type = ATK_SLASH,
		power = 300,
		accuracy = 100,
		costtype = CST_HPPERCENT,
		cost = 16,
		critical = 3,
		technical = COND_FREEZE,
		desc = "Slices up all enemies at high speed.\nMedium Slash Damage",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #hittargets
				local color = SKINCOLOR_WHITE
				local target = hittargets[i]
				local time = timer - (i-1)*6

				if time == 1
					target.rolls = {}

				elseif time == 15
				or time == 20
				or time == 25	-- lazy
					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.state = S_SLASHING_2_1
					s.color = color
					s.scale = FRACUNIT*3
					playSound(mo.battlen, sfx_slash)
					s.rollangle = P_RandomRange(0, 359)*ANG1
					target.rolls[#target.rolls+1] = s.rollangle

				elseif time == 17
				or time == 22
				or time == 27

					if time == 22
					and not (i%2)

						local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
						d.sprite = SPR_THMP
						d.frame = C|FF_FULLBRIGHT
						d.scale = FRACUNIT/4
						d.destscale = FRACUNIT*3
						d.scalespeed = FRACUNIT/8
						d.fuse = TICRATE-10
						d.tics = d.fuse
						d.momz = FRACUNIT*2
						d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
						d.color = color
					end

					local s = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
					s.scale = FRACUNIT/4
					s.sprite = SPR_SLAS
					s.frame = I|TR_TRANS50 + P_RandomRange(0, 3)
					s.destscale = FRACUNIT*9
					s.scalespeed = FRACUNIT
					s.tics = TICRATE/3


				elseif time == 19
				or time == 24
				or time == 29

					if time == 24
						damageObject(target)
						playSound(mo.battlen, sfx_bexpld)
						if not target.plyr
							createSplat(mo)
							createSplat(mo)
						end
						localquake(mo.battlen, FRACUNIT*10, 10)
					end

					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = color

					s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = G|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.tics = TICRATE/2
					s.fuse = s.tics
					s.destscale = FRACUNIT*10
					s.scalespeed = FRACUNIT/4
					s.color = color
					s.rollangle = target.rolls[#target.rolls]
				end
			end

			if timer == 55 + (#hittargets-1)*6
				return true
			end
		end,
}

attackDefs["motivate"] = {
		name = "Motivate",
		type = ATK_SUPPORT,
		costtype = CST_SP,
		cost = 30,
		desc = "An encouraging shout to the allies.\nRaises Attack and Heals 20 SP",
		target = TGT_ALLALLIES,
		buff = true,
		showsp = true,
		anim = function(mo, targets, hittargets, timer)

			for i = 1, #targets do

				local target = targets[i]

				if timer == 20 + (i-1)*8
					playSound(mo.battlen, sfx_courge)
					VFX_Play(target, VFX_SUMMON)
					buffStat(target, "atk")
					damageSP(target, -20)
					for i = 1,16
						local dust = P_SpawnMobj(target.x, target.y, target.z, MT_DUMMY)
						dust.angle = ANGLE_90 + ANG1* (22*(i-1))
						dust.state = S_CDUST1
						P_InstaThrust(dust, dust.angle, 30*FRACUNIT)
						dust.color = SKINCOLOR_SUPERRED3
						dust.scale = FRACUNIT*2
					end

				elseif timer > 20 + (i-1)*8 and timer <= 50 + (i-1)*8

					if leveltime%2 == 0
						for i = 1,16

							local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
							thok.sprite = SPR_SUMN
							thok.frame = F|FF_FULLBRIGHT|TR_TRANS70
							thok.momz = P_RandomRange(3, 10)*FRACUNIT
							thok.color = SKINCOLOR_KETCHUP
							thok.tics = P_RandomRange(10, 35)
							thok.scale = FRACUNIT*3/2
						end
					end

					for i = 1, 8
						local thok = P_SpawnMobj(target.x+P_RandomRange(-70, 70)*FRACUNIT, target.y+P_RandomRange(-70, 70)*FRACUNIT, target.z+P_RandomRange(0, 50)*FRACUNIT, MT_DUMMY)
						thok.sprite = SPR_SUMN
						thok.frame = F|FF_FULLBRIGHT|TR_TRANS50
						thok.momz = P_RandomRange(6, 16)*FRACUNIT
						thok.color = SKINCOLOR_SALMON
						thok.tics = P_RandomRange(10, 35)
					end
				end
			end
			if timer == 60 + (#targets-1)*16
				return true
			end
		end,
}

attackDefs["flame_dragon"] = {
		name = "Flame Dragon",
		type = ATK_FIRE,
		power = 410,
		accuracy = 95,
		costtype = CST_HPPERCENT,
		cost = 10,
		critical = 3,
		status = COND_BURN,
		statuschance = 10,
		desc = "Strikes all enemies with a Fire Move\ncausing Heavy Damage to all enemies",
		target = TGT_ALLENEMIES,
		anim = function(mo, targets, hittargets, timer)
				for i = 1, #hittargets
					local target = hittargets[i]

					local t = timer - (i-1)*6

				if timer == 15
					local s = P_SpawnMobj(target.x, target.y, target.z+1*FRACUNIT, MT_DUMMY)
					s.state = S_SLASHING_1_1
					s.color = SKINCOLOR_RED
					s.scale = FRACUNIT*3/2
					playSound(mo.battlen, sfx_slash)

				elseif timer == 17
					local d = P_SpawnMobj(target.x, target.y, target.z+128*FRACUNIT, MT_THOK)
					d.sprite = SPR_THMP
					d.frame = C|FF_FULLBRIGHT
					d.scale = FRACUNIT/4
					d.destscale = FRACUNIT*3
					d.scalespeed = FRACUNIT/8
					d.fuse = TICRATE-10
					d.tics = d.fuse
					d.momz = FRACUNIT*2
					d.momx = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.momy = P_RandomRange(0, FRACUNIT-1)*P_RandomRange(-8, 8)
					d.color = SKINCOLOR_RED

				elseif timer == 19

					DoExplosion(target)
					damageObject(target)
					if not target.plyr
						createSplat(mo)
						createSplat(mo)
					end
					localquake(mo.battlen, FRACUNIT*10, 10)
					for i=1,20
						local b = P_SpawnMobj(target.x, target.y, target.z+20*FRACUNIT, MT_DUMMY)
						b.momx = P_RandomRange(-8, 8)*FRACUNIT
						b.momy = P_RandomRange(-8, 8)*FRACUNIT
						b.momz = P_RandomRange(-8, 8)*FRACUNIT
						b.state = S_QUICKBOOM1
						b.scale = FRACUNIT*3
					end
	
					local s = P_SpawnMobj(target.x, target.y, target.z+40*FRACUNIT, MT_THOK)
					s.sprite = SPR_SLSH
					s.frame = I|FF_FULLBRIGHT
					s.scale = FRACUNIT/2
					s.destscale = FRACUNIT*4
					s.scalespeed = FRACUNIT/3
					s.color = SKINCOLOR_RED

				elseif timer == 45 + (#hittargets-1)*6
					target.slashsprite = nil
					return true
				end
			end	
		end,
}